import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Lithobox2 extends PApplet {


/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
String session_name = "Lithobox Generated Models/";

int STAGE = 0;
// stage 1 outline
// stage 2 inners
// stage 3 export

public void setup() {
  
  setupBoxButtons();
  setupInchScales();
  loadPreview();
  drawingBox = loadImage("vase.png");
  proportionDrawingBox();
  
 // println(drawingBox.height);
}

int backgroundColor = 50;
boolean scaleExportInMilimeters = true; // inches or milimeters
public void draw() {

  background(backgroundColor);

  showSteps(STAGE);
  if (STAGE == 0) {
    step0();
  } else if (STAGE == 1) {
    step1();
  } else if (STAGE == 2) {
    step2();
  } else {
    step3();
    if (saveScreenUp && saveStep == "saving" && delay > 2) {
      printVase(year()+"_"+month()+"_"+day()+"_"+hour()+"_"+minute()+"_"+second());
      saveStep = "saved";
      delay = 0;
    }
  }
}


public void keyPressed() {
  if (key == 's' || key == 'S') {
    saveFrame("test-#########.png");
  } else if (key == 'p' || key == 'P') {
    // printVase("test-#########.obj");
  }
} 

public void mousePressed() {
  if (STAGE == 0) {
    if (stepButtons_0.get(0).mouseOver()) {
      STAGE = 1;
    }
  } else if (STAGE == 1) {
    if (stepButtons_1.get(0).mouseOver()) {
      loadPreview();
      STAGE = 2;
      if (changesMade) {
        updatePreviewVase();
        changesMade = false;
      }
    } else if (stepButtons_1.get(1).mouseOver()) {
      if (drawnInBox) {  
        drawnBoxSave = drawingBox.get(); 
        set4thBox();
      }
      drawingBox = loadImage(stepButtons_1.get(1).text);
      proportionDrawingBox();
      changesMade = true;
    } else if (stepButtons_1.get(2).mouseOver()) {
      if (drawnInBox) {  
        drawnBoxSave = drawingBox.get(); 
        set4thBox();
      }
      drawingBox = loadImage(stepButtons_1.get(2).text);
      proportionDrawingBox();
      changesMade = true;
    } else if (stepButtons_1.get(3).mouseOver()) {
      if (drawnInBox) {  
        drawnBoxSave = drawingBox.get();  
        set4thBox();
      }
      drawingBox = loadImage(stepButtons_1.get(3).text);
      proportionDrawingBox();
      changesMade = true;
    } else if (stepButtons_1.get(4).mouseOver()) {
      PImage tmp = drawnBoxSave.get();
      if (drawnInBox) {  
        drawnBoxSave = drawingBox.get(); 
        set4thBox();
      }
      drawingBox = tmp.get();
      proportionDrawingBox();
      drawnInBox = true;
      changesMade = true;
    } else if (stepButtons_1.get(5).mouseOver()) {
      stepButtons_1.get(5).clicked = true;
      selectInput("Select a file to process:", "fileSelected");
    }
    //  selectInput("Select a file to process:", "fileSelected");
  } else if (STAGE == 2) {
    if (stepButtons_2.get(0).mouseOver()) {
      STAGE = 3;
    } else if (stepButtons_2.get(1).mouseOver()) {
      if (outerImageWhite) {
        stepButtons_2.get(1).clicked = true;
        selectInput("Select a file to process:", "fileSelected");
      } else {
        newOuterPreviewImg = true;
        outerImageWhite = true;
        img1 = "nocutout.png";
        loadPreview();
      }
    } else if (stepButtons_2.get(2).mouseOver()) {
      if (innerImageWhite) {
        stepButtons_2.get(2).clicked = true;
        selectInput("Select a file to process:", "fileSelected");
      } else {
        newInnerPreviewImg = true;
        innerImageWhite = true;
        img2 = "nocutout.png";
        loadPreview();
      }
    }
  } else if (STAGE == 3) {
    if (saveScreenUp == true) {
      if (saveButtons.get(0).mouseOver()) {
        saveScreenUp = false;
      } else if (saveButtons.get(1).mouseOver()) {
        exit();
      }
    } else if (stepButtons_3.get(0).mouseOver()) {
      folderName = session_name+hour()+"_"+minute()+"_"+second()+"/";
      save(folderName+year()+"_"+month()+"_"+day()+"_"+hour()+"_"+minute()+"_"+second()+"-preview.png");
      saveScreenUp = true;
      saveStep = "saving";
      // printVase(year()+"_"+month()+"_"+day()+"_"+hour()+"_"+minute()+"_"+second());
      // saveStep = "saved";
    } else if (vaseHEIGHT_inches.mouseOver()) {
      if (vaseHEIGHT_inches.arrows.get(0).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(0, 1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(1).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(1, 1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(2).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(2, 1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(3).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(0, -1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(4).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(1, -1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(5).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(2, -1);
        setWIDTHbasedOnHEIGHT(true);
      }
    } else if (vaseWIDTH_inches.mouseOver()) {
      if (vaseWIDTH_inches.arrows.get(0).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(0, 1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(1).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(1, 1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(2).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(2, 1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(3).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(0, -1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(4).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(1, -1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(5).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(2, -1);
        setHEIGHTbasedOnWIDTH(true);
      }
    }
  }

  // check for top buttons

  if (saveScreenUp == false && PVector.dist(new PVector(steps_center-steps_inBetween, steps_distFromTop+steps_orbSize), new PVector(mouseX, mouseY)) < steps_orbSize) { // 1
    STAGE = 1;
  } else if (saveScreenUp == false && PVector.dist(new PVector(steps_center, steps_distFromTop+steps_orbSize), new PVector(mouseX, mouseY)) < steps_orbSize) { // 1
    loadPreview();
    STAGE = 2;
    if (changesMade) {
      updatePreviewVase();
      changesMade = false;
    }
  } else if (saveScreenUp == false && PVector.dist(new PVector(steps_center+ steps_inBetween, steps_distFromTop+steps_orbSize), new PVector(mouseX, mouseY)) < steps_orbSize) { // 1
    loadPreview();
    STAGE = 3;
    if (changesMade) {
      updatePreviewVase();
      changesMade = false;
    }
  }
}





public void mouseDragged() 
{
  // if inside box
  if (STAGE==1 && mouseX > dB_x - dB_wid && mouseX < dB_x + dB_wid && mouseY > dB_y && mouseY < dB_y + dB_hei) {
    drawInBox1();
  }
}

/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
class BoxButton {

  float x;
  float y;
  float wid;
  float hei;
  String text;
  String text_alternate;
  int textSize;

  int col;
  int hover_col;
  int text_col;
  int text_hover_col;

  Boolean pictureButton;
  PImage picture;

  Boolean clicked;

  BoxButton(float _x, float _y, float _w, float _h, String _t, int _ts, Boolean p) {
    x = _x;
    y = _y;
    wid = _w;
    hei = _h;
    text = _t;
    String[] list = split(text, '/');
    if(list.length > 1){
      text = list[0];
      text_alternate = list[1];
    }
    textSize = _ts;
    
    pictureButton = p;
    if(pictureButton){
      picture = loadImage(textSize+".png");
    }
    
    col = color(100, 100, 100);
    hover_col= color(200, 200, 200);
    text_col= color(200, 200, 200);
    text_hover_col= color(50, 50, 50);

    clicked = false;
  }

  public Boolean mouseOver() {  
    if (mouseX > x && mouseX < x+wid && mouseY > y && mouseY < y+hei) {
      return true;
    } else {
      return false;
    }
  }

  public void render(Boolean b) {
    stroke(color(107, 191, 236));
    
    String t = text;
    if(!b){ t = text_alternate; }
    
    if (!pictureButton) {
      textSize(textSize);
      if (mouseOver()) {
        fill(hover_col);
        rect(x, y, wid, hei);
        fill(text_hover_col);
        text(t, x+(wid/2), y+(textSize/2)+(hei/2));
      } else {
        fill(col);
        rect(x, y, wid, hei);
        fill(text_col);
        text(t, x+(wid/2), y+(textSize/2)+(hei/2));
      }
    }else{ // pictures
         if (mouseOver()) {
        fill(hover_col);
      } else {
        fill(col);
      }
      rect(x, y, wid, hei);
      image(picture, x, y, wid, hei);
    }
  }
}

///////////All Buttons

ArrayList<BoxButton> stepButtons_0 = new ArrayList<BoxButton>();
ArrayList<BoxButton> stepButtons_1 = new ArrayList<BoxButton>();
ArrayList<BoxButton> stepButtons_2 = new ArrayList<BoxButton>();
ArrayList<BoxButton> stepButtons_3 = new ArrayList<BoxButton>();
ArrayList<BoxButton> saveButtons = new ArrayList<BoxButton>();

public void setupBoxButtons() {

  stepButtons_0.add(new BoxButton((width/2)-75, 400, 150, 75, "START", 16, false));


  stepButtons_1.add(new BoxButton(width-200, height-150, 150, 75, "CONTINUE", 16,  false));
  stepButtons_1.add(new BoxButton(40, height-130, 75, 75, "orb.png", 1,  true));
  stepButtons_1.add(new BoxButton(120, height-130, 75, 75, "cylinder.png", 2,  true));
  stepButtons_1.add(new BoxButton(200, height-130, 75, 75, "vase.png", 3,  true));
  stepButtons_1.add(new BoxButton(280, height-130, 75, 75, "blank", 4,  true));
  stepButtons_1.add(new BoxButton(360, height-130, 150, 75, "UPLOAD IMAGE", 16,  false));


  stepButtons_2.add(new BoxButton(width-200, height-150, 150, 75, "CONTINUE", 16,  false));
  stepButtons_2.add(new BoxButton(75, 100, 150, 66, "ADD OUTER IMAGE/RESET OUTER IMAGE", 12,  false));
  stepButtons_2.add(new BoxButton(75, 200, 150, 66, "ADD INNER IMAGE/RESET INNER IMAGE", 12, false));

  stepButtons_3.add(new BoxButton(width-200, height-150, 150, 75, "EXPORT", 16, false));
  
  saveButtons.add(new BoxButton((width/2)-160, 350, 120, 60, "CONTINUE", 16, false));
  saveButtons.add(new BoxButton((width/2)+40, 350, 120, 60, "EXIT", 16, false));
  
  step2ExampleSrcImg = loadImage("exampleSrc.png");
}


public void set4thBox(){  // set image for 4th button based on previous image
  int border = 6;
  PImage tmp = drawnBoxSave.get();
  int newH = stepButtons_1.get(4).picture.height-(border*2);
  int newW = PApplet.parseInt( PApplet.parseFloat(newH) * PApplet.parseFloat(tmp.width) / PApplet.parseFloat(tmp.height));
  tmp.resize(newW, newH);
  tmp.loadPixels();
  stepButtons_1.get(4).picture.loadPixels();
  for(int y=0; y<stepButtons_1.get(4).picture.height; y++){
    for(int x=0; x<stepButtons_1.get(4).picture.width; x++){
      int loc = (x) + (y+2)*stepButtons_1.get(4).picture.width;
      if(x>border&&x<newH && y>border&&y<newH){
         int srcLoc = 0;
         if(x>stepButtons_1.get(4).picture.width/2){
           srcLoc = (x-(stepButtons_1.get(4).picture.width/2)) + ((y-border)*tmp.width);
         }else{
           srcLoc = ((stepButtons_1.get(4).picture.width/2)-(x-border)) + ((y-border)*tmp.width);
         }
         
         if(red(tmp.pixels[srcLoc]) > 127){
           stepButtons_1.get(4).picture.pixels[loc] =  color(255,255);
         }else{
           stepButtons_1.get(4).picture.pixels[loc] =  color(255,0);
         }
         
      }
     // else{
       // stepButtons_1.get(4).picture.pixels[loc] =  color(255,0);
     // }
    }
  }
  stepButtons_1.get(4).picture.updatePixels();
}

/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
public ArrayList<PVector> GaussianBlur1D(ArrayList<PVector> oldA){
  
  ArrayList<PVector> newA = new ArrayList<PVector>();
  int spread = 10;
  
  for(int i=0; i<oldA.size(); i++){
    float totalValue = 0;
    float totalDivider = 0;
    
    int min = i-spread;
    int max = i+spread;
    while(min < 0){
          min++;
          max--;
    }
    while(max >= oldA.size()){
          min++;
          max--;
    }
    
    for(int k=min; k<=max; k++){
     // if(k>=0 && k<oldA.size()){
        float relativePull = powerToDistance(abs(i-k));
        float varX = oldA.get(k).x;
        
        totalValue += (varX/relativePull);
        totalDivider += (1.0f/relativePull);
     // }      
    }
       //println(totalValue +"  " + totalDivider);
       // only copy over new X, Y should stay the same
    newA.add(new PVector(  totalValue / totalDivider  , oldA.get(i).y) );     
    
  }
 // println(newA);
  return newA;
}


public float powerToDistance(float p){
  
  float n = pow(p+1, .5f);
  
  return n;
  
}//*/

/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
boolean saveOBJ = true;
PrintWriter output;
int ptNum = 1;

PImage pImg; 
String image_name = "test3.png"; // side view

Boolean blendVase = true;

PImage outerSurface;
PImage innerSurface;
String img1 = "nocutout.png"; // outer image
String img2 = "nocutout.png"; // inner image

/// need 2 because they will be resized differently for outer and inner
PImage cutOutImage_out;
PImage cutOutImage_in;
String img3 = "nocutout.png";
Vase v;

String mostRecentName = "";

String folderName = "";


PGraphics sideVisualizer; // (for beta testing wall thickness consistency)
boolean sideVisTurnedOn = false;

public void printVase(String name) {
  mostRecentName = name;
  float horizontal = 600; // horizontal and vertical should be divisible by 10
  float vertical = 600;
  
  if(sideVisTurnedOn){sideVisualizer = createGraphics(PApplet.parseInt(horizontal), PApplet.parseInt(vertical*2));}

  int surfaceSides = 600;
  
  // defaults, these values are changed later further down
  float depthOfSurfaceOuter = 5;
  float depthOfSurfaceInner = 7; //5
  float thickness = .2f; // full thickness //3
  float scaler = 1;

  pImg = drawingBox.get();
  float ratio = PApplet.parseFloat(pImg.width) / PApplet.parseFloat(pImg.height);

  if (ratio > 1) {
    vertical = horizontal / ratio;
  } else {
    horizontal = vertical * ratio;
  }
  int segLength = 2;
  pImg.resize(PApplet.parseInt(horizontal/segLength), PApplet.parseInt(vertical/segLength));
  
  
  float print_Height = 1;
  float scalerFormat = 1;
  if(!scaleExportInMilimeters){
    print_Height = vaseHEIGHT_inches.getNumberInches();
  }else{
    print_Height = vaseHEIGHT_inches.getNumberMilimeters();
    scalerFormat = 25.4f;
  }
  //------------------------------------------
  //------------------------------------------
  // set scaler, thickness, and depth of Surface outer and inner
  float minimizer = .07f;
  float minimizer_inner = .12f;
  scaler = print_Height /  pImg.height;
  thickness = scalerFormat * (.04f *.3f) * (PApplet.parseFloat(pImg.height) / print_Height);
  depthOfSurfaceOuter = scalerFormat * minimizer * (PApplet.parseFloat(pImg.height) / print_Height);
  depthOfSurfaceInner = scalerFormat * minimizer_inner  * (PApplet.parseFloat(pImg.height) / print_Height);
  
 // println(scaler+" "+thickness+" "+depthOfSurfaceOuter);
  //------------------------------------------
  //------------------------------------------
 // outerSurface = outerPreview.get();  //loadImage(img2)
 // innerSurface = innerPreview.get(); //loadImage(img2);
  cutOutImage_out = loadImage(img3);
  cutOutImage_in = loadImage(img3);
  
  outerSurface.save(folderName+"outer image.png");
  innerSurface.save(folderName+"inner image.png");

  output = createWriter(folderName+name+".obj");

  output.println("# Blender3D v249 OBJ File:");
  output.println("# www.blender3d.org");
  output.println("mtllib texture_circ.mtl");


  v = new Vase(pImg, outerSurface, innerSurface, cutOutImage_out, cutOutImage_in, surfaceSides, depthOfSurfaceOuter, depthOfSurfaceInner, thickness, scaler);

  output.flush();
  output.close();
  saveOBJ = false;
  
  drawingBox.save(folderName+name+".png");
  
  ptNum = 1;
}

class Vase {
  float x;
  float y;
  float z;
  float x_length;
  float y_length;
  float z_length;

  int [][] relief_outer;
  int [][] relief_inner;

  ArrayList<PVector> outerPts;
  ArrayList<PVector> innerPts;

  int cols = 0;
  int rows = 0;

  // number of vector points in each ring of vase
  int sides;
  float surfaceDepth_outer;
  float surfaceDepth_inner;
  float THICKNESS;
  float SCALER;

  Vase(PImage img, PImage img_outer, PImage img_inner, PImage cut_out, PImage cut_in, int s, float d1, float d2, float t, float sca) {

    outerPts = new ArrayList<PVector>();
    innerPts = new ArrayList<PVector>();

    sides = s;
    surfaceDepth_outer = d1;
    surfaceDepth_inner = d2;
    THICKNESS = t;
    SCALER = sca;
    relief_mesh(img, img_outer, img_inner, cut_out, cut_in);
    
    
    
  
  }




  public void relief_mesh(PImage src, PImage img_outer, PImage img_inner, PImage cut_out, PImage cut_in) {
   // println(SCALER);
    src.loadPixels(); 

    rows = src.width;
    cols = src.height;
    //  bas_relief = new float[rows][cols];

    ////// GENERATE POINTS FOR OUTER VASE
    //  int actualCols_outer = 0;
    int previous = -1; // -1 if no data, 0 if black (less than 127), 1 if white (more than 127)
    for (int pic_y = 0; pic_y < cols; pic_y++) {
      for (int pic_x = 0; pic_x < rows; pic_x++) {

        int src_loc = (pic_x) + (pic_y)*(src.width);

        float r = red(src.pixels[src_loc]);
        float g = green(src.pixels[src_loc]);
        float b = blue(src.pixels[src_loc]);

        float c = (r+g+b)/(255*3); // gets to greyscale between 0 and 1

        if (c<.5f && previous == 1) {
          // generate ring based on pic_x as radius
          outerPts.add(new PVector(pic_x, pic_y));// + THICKNESS
          //actualCols_inner++;
        }

        if (c>.5f) { 
          previous = 1;
        } else { 
          previous = 0;
        }

        /* if (c>.5 && previous == 0) {
         // used to - generate ring based on pic_x as radius
         outerPts.add(new PVector(pic_x + THICKNESS, pic_y));
         //  actualCols_outer++;
         }
         
         if (c>.5) { 
         previous = 1;
         } else { 
         previous = 0;
         }//*/
      }
      previous = -1;
    }

    // println("outerPoints" + outerPts);
    if (blendVase) {
      outerPts = GaussianBlur1D(outerPts);
    }

    ////// GENERATE OUTER POINTS (SURFACE RING)
    relief_outer = new int[sides][outerPts.size()];
    img_outer.resize(  sides, outerPts.size());
    img_outer.loadPixels();

    cut_out.resize(sides, outerPts.size());
    cut_out.loadPixels();


    for (int k=0; k<outerPts.size(); k++) {
      float px = outerPts.get(k).x;
      float py = outerPts.get(k).y;
      
      PVector surfaceThick = new PVector(0, 1); 

      if (k>0 && k<outerPts.size()-1) {
        PVector o2 = PVector.sub(new PVector(outerPts.get(k-1).x, outerPts.get(k-1).y), new PVector(outerPts.get(k+1).x, outerPts.get(k+1).y));
        float an= o2.heading();
          surfaceThick.rotate(an);
      } else if (k==0) {
        PVector o2 = PVector.sub(new PVector(outerPts.get(k).x, outerPts.get(k).y), new PVector(outerPts.get(k+1).x, outerPts.get(k+1).y));
        float an= o2.heading();
          surfaceThick.rotate(an);
      } else { // k == outerPts.size()-1
        PVector o2 = PVector.sub(new PVector(outerPts.get(k-1).x, outerPts.get(k-1).y), new PVector(outerPts.get(k).x, outerPts.get(k).y));
        float an= o2.heading();
          surfaceThick.rotate(an);
      }

      
      
                   ///////////////////////////////////////////////////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////////
      
        if(sideVisTurnedOn){
          
          surfaceThick.mult(100);
          PVector p2= PVector.add(surfaceThick, outerPts.get(k));
          
          float scala = 4;
      sideVisualizer.beginDraw();
 
    sideVisualizer.stroke(255);
    sideVisualizer.strokeWeight(2);
     sideVisualizer.line(outerPts.get(k).x*scala, outerPts.get(k).y*scala, p2.x*scala,p2.y*scala);
      sideVisualizer.endDraw();
        }
      
      
      ///////////////////////////////////////////////////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////////
     
      
      
      
      /// println(surfaceThick);
      float angle = 360 / PApplet.parseFloat(sides);
      for (int i = 0; i < sides; i++) {
        int src_loc = (k*sides)+i;

        float cutR = red(cut_out.pixels[src_loc]);
        float cutG = green(cut_out.pixels[src_loc]);
        float cutB = blue(cut_out.pixels[src_loc]);

        if (!(cutR>200 && cutG<50 && cutB<50)) { // if red

          float r = red(img_outer.pixels[src_loc]);
          float g = green(img_outer.pixels[src_loc]);
          float b = blue(img_outer.pixels[src_loc]);

          float c = 1.0f- ((r+g+b)/(255*3)); // gets to greyscale between 0 and 1

          PVector sT = new PVector(surfaceThick.x, surfaceThick.y);
          sT.setMag((c*surfaceDepth_outer) + THICKNESS);
          float px2 = (px + sT.x);
          float py2 = py + sT.y;
          
          if(py2 > outerPts.get(outerPts.size()-1).y){
              py2 = outerPts.get(outerPts.size()-1).y; 
          }

          float x = cos( radians( i * angle ) ) * px2;
          float z = sin( radians( i * angle ) ) * px2;
          PVector e = warp(new PVector(x, py2, z), true);
          output.println("v "+(e.x*SCALER)+" "+(e.y*SCALER)+" "+(e.z*SCALER));
          relief_outer[i][k] = ptNum;
          ptNum++;
        } else {
          relief_outer[i][k] = -1;
        }
      }
    }
    img_outer.updatePixels();
    cut_out.updatePixels();


    ////// CONNECTING SIDES FOR OUTER CYLINDER
    for (int t_y = 0; t_y < outerPts.size(); t_y++) {
      for (int t_x = 0; t_x < sides; t_x++) {
        int curnt = relief_outer[t_x][t_y];
        if (curnt != -1) {
          if (t_y>0) {
            int up1 = relief_outer[t_x][t_y-1];
            int left1;
            if (t_x>0) {
              left1 = relief_outer[t_x-1][t_y];
            } else {
              left1 = relief_outer[sides-1][t_y];
            }
            if (up1 != -1 && left1 != -1) {
              output.println("f "+curnt+" "+up1+" "+left1);
            }
          }
          if (t_y<outerPts.size()-1) {
            int down1 = relief_outer[t_x][t_y+1];
            int right1;
            if (t_x<sides-1) {
              right1 = relief_outer[t_x+1][t_y];
            } else {
              right1 = relief_outer[0][t_y];
            }
            if (down1 != -1 && right1 != -1) {
              output.println("f "+curnt+" "+down1+" "+right1);
            }
          }
        }
      }
    }//*/
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    //int insidePtNum = ptNum;
    Boolean hollowTop = true;
    Boolean hollowBottom = true;
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////

    ////// GENERATE POINTS FOR INNER VASE
    //int actualCols_inner = 0;
    IntList innerBreaks = new IntList(); 
    previous = -1; // -1 if no data, 0 if black (less than 127), 1 if white (more than 127)
    Boolean hollowLine = false;
    for (int pic_y = 0; pic_y < cols; pic_y++) {
      for (int pic_x = 0; pic_x < rows; pic_x++) {

        int src_loc = ((pic_x)) + ((pic_y))*(src.width);
        //int src_loc = ((pic_x*segLength)) + ((pic_y*segLength))*(src.width);

        float r = red(src.pixels[src_loc]);
        float g = green(src.pixels[src_loc]);
        float b = blue(src.pixels[src_loc]);

        float c = (r+g+b)/(255*3); // gets to greyscale between 0 and 1

        if (c<.5f && previous == 1) {
          // generate ring based on pic_x as radius
          innerPts.add(new PVector(pic_x, pic_y));//- THICKNESS
          //actualCols_inner++;
          hollowLine = true;
        }

        if (c>.5f) { 
          previous = 1;
        } else { 
          previous = 0;
        }

      }
      previous = -1;
      if (hollowLine == false) {
        if (pic_y == 0) { 
          hollowTop = false;
        } else if (pic_y == cols-1) { 
          hollowBottom = false;
        }


        if (innerBreaks.size() == 0 || innerBreaks.get(innerBreaks.size()-1) != innerPts.size()) {
          innerBreaks.append(innerPts.size()-1);
        }
      }
      hollowLine = false;
      
      /// move innerpoint based on position of outerPoints
      ////////////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////////////////////////////////////////////////////
      
      int t=innerPts.size()-1;
      float px = outerPts.get(t).x;
      float py = outerPts.get(t).y;

      /// rotate vector so it points away from bowl
      PVector upP = new PVector(0, 0);
      PVector downP = new PVector(0, 0);
      if (t>0) {
       // upP = new PVector(outerPts.get(t-1).x, outerPts.get(t-1).y);
        upP = PVector.sub(upP, new PVector(px, py));
      }
      if (t<outerPts.size()-1) {
       // downP = new PVector(outerPts.get(t+1).x, outerPts.get(t+1).y);
        downP = PVector.sub(downP, new PVector(px, py));
      }

      PVector surfaceThick = new PVector(0,1); 

      if (t>0 && t<outerPts.size()-1) {
      PVector o2 = PVector.sub(new PVector(outerPts.get(t+1).x, outerPts.get(t+1).y), new PVector(outerPts.get(t-1).x, outerPts.get(t-1).y));
        float an= o2.heading();
               surfaceThick.rotate(an);
             
      } else if (t==0) {
        PVector o2 = PVector.sub(new PVector(outerPts.get(t+1).x, outerPts.get(t+1).y), new PVector(outerPts.get(t).x, outerPts.get(t).y));
        float an= o2.heading();
        surfaceThick = new PVector(0,1); 
          surfaceThick.rotate(an);
      } else if(t==outerPts.size()-1) { // k == outerPts.size()-1
        PVector o2 = PVector.sub(new PVector(outerPts.get(t).x, outerPts.get(t).y), new PVector(outerPts.get(t-1).x, outerPts.get(t-1).y));
        float an= o2.heading();
        surfaceThick.rotate(an);
      }
      float dist = SCALER * THICKNESS;
      surfaceThick.setMag(dist);
      PVector p = PVector.add(surfaceThick, outerPts.get(t));
     
  
     
      
      
      innerPts.set(t, p);
      

     
      /////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////////////////////////////////////////////////////
      
    }

    //   println("innerPoints" + innerPts);
    if (blendVase) {
      innerPts = GaussianBlur1D(innerPts);
    }

    ///////GENERATE INNER POINTS (SURFACE RING)
    relief_inner = new int[sides][innerPts.size()];
    // img_inner.resize(  sides, innerPts.size());
    img_inner.resize(  sides, outerPts.size());
    img_inner.loadPixels();
    //cut_in.resize(sides, innerPts.size());
    cut_in.resize(sides, outerPts.size());
    cut_in.loadPixels();


    for (int k=0; k<innerPts.size(); k++) {

      
            int t=k;
      float px = outerPts.get(t).x;
      float py = outerPts.get(t).y;

      /// rotate vector so it points away from bowl
    
      PVector surfaceThick = new PVector(0, 1); 

      if (t>0 && t<outerPts.size()-1) {
        PVector o2 = PVector.sub(new PVector(outerPts.get(t+1).x, outerPts.get(t+1).y), new PVector(outerPts.get(t-1).x, outerPts.get(t-1).y));
        float an= o2.heading();
          surfaceThick.rotate(an);
      } else if (t==0) {
        PVector o2 = PVector.sub(new PVector(outerPts.get(t+1).x, outerPts.get(t+1).y), new PVector(outerPts.get(t).x, outerPts.get(t).y));
        float an= o2.heading();
          surfaceThick.rotate(an);
      } else { // k == outerPts.size()-1
        PVector o2 = PVector.sub(new PVector(outerPts.get(t).x, outerPts.get(t).y), new PVector(outerPts.get(t-1).x, outerPts.get(t-1).y));
        float an= o2.heading();
          surfaceThick.rotate(an);
      }

      //*/


      float angle = 360 / PApplet.parseFloat(sides);
      for (int i = 0; i < sides; i++) {
        

        /// try to resize 
        float k2 = PApplet.parseFloat(k)*(PApplet.parseFloat(outerPts.size())/PApplet.parseFloat(innerPts.size()));
        int _k2 = 0;
        if (k2-PApplet.parseInt(k2)<.5f) {
          _k2 = PApplet.parseInt(k2);
        } else {
          _k2 = PApplet.parseInt(k2)+1;
        }


        int src_loc = (_k2*sides)+i;


        float cutR = red(cut_in.pixels[src_loc]);
        float cutG = green(cut_in.pixels[src_loc]);
        float cutB = blue(cut_in.pixels[src_loc]);

        if (!(cutR>200 && cutG<50 && cutB<50)) { // if red
          float r = red(img_inner.pixels[src_loc]);
          float g = green(img_inner.pixels[src_loc]);
          float b = blue(img_inner.pixels[src_loc]);

          float c = 1.0f - ((r+g+b)/(255*3)); // gets to greyscale between 0 and 1

          PVector sT = new PVector(surfaceThick.x, surfaceThick.y);
          sT.setMag((c*surfaceDepth_inner) + THICKNESS);
          float px2 = (px + sT.x);
          float py2 = py + sT.y;
          
         

          float x = cos( radians( i * angle ) ) * px2;
          float z = sin( radians( i * angle ) ) * px2;
          PVector e = new PVector(x, py2, z);  //warp(new PVector(x, py2, z), false);
          float s = (sides / 9);
          if(e.y*SCALER >(vaseHEIGHT_inches.getNumberMilimeters()-7) && ((i<s)|| (i>=(s*3) && i<(s*4)) ||  (i>=(s*6) && i<(s*7))   )){
             px2 = 17;
             e.x = cos( radians( i * angle ) ) * px2;
             e.z = sin( radians( i * angle ) ) * px2;

               if(e.y > outerPts.get(outerPts.size()-1).y){
              e.y = outerPts.get(outerPts.size()-1).y - ((outerPts.size()-1-k)*.001f); 
          }
          
             output.println("v "+(e.x)+" "+(e.y*SCALER)+" "+(e.z));  
          }else{
            
            if(e.y > outerPts.get(outerPts.size()-1).y){
              e.y = outerPts.get(outerPts.size()-1).y; 
          }
          
          
             output.println("v "+(e.x*SCALER)+" "+(e.y*SCALER)+" "+(e.z*SCALER));  
          }
      
          relief_inner[i][k] = ptNum;
          ptNum++;
        } else {
          relief_inner[i][k] = -1;
        }
      }
    }
    img_inner.updatePixels();
    cut_in.updatePixels();//*/






    ////// CONNECTING FACES FOR INSIDE OF CYLINDER
    for (int t_y = 0; t_y < innerPts.size(); t_y++) {
      for (int t_x = 0; t_x < sides; t_x++) {
        int curnt = relief_inner[t_x][t_y];
        if (curnt != -1) {
          if (t_y>0) {
            int up1 = relief_inner[t_x][t_y-1];
            int left1;
            if (t_x>0) {
              left1 = relief_inner[t_x-1][t_y];
            } else {
              left1 = relief_inner[sides-1][t_y];
            }
            if (up1 != -1 && left1 != -1) {
              output.println("f "+curnt+" "+left1+" "+up1);
            }
          }
          if (t_y<innerPts.size()-1) {
            int down1 = relief_inner[t_x][t_y+1];
            int right1;
            if (t_x<sides-1) {
              right1 = relief_inner[t_x+1][t_y];
            } else {
              right1 = relief_inner[0][t_y];
            }
            if (down1 != -1 && right1 != -1) {
              output.println("f "+curnt+" "+right1+" "+down1);
            }
          }
        }
      }
    }




    ////// TIE OUTER AND INNER AT TOP
    if (!hollowTop) { // if top is solid
      /// inner
      output.print("f ");
      for (int t_x = sides-1; t_x >= 0; t_x--) {
        if (relief_inner[t_x][0] != -1) {
          output.print( (relief_inner[t_x][0]) + " ");
        }
      } 
      output.println(" ");
      // outer
      output.print("f ");
      for (int t_x = 0; t_x < sides; t_x++) {
        if (relief_outer[t_x][0] != -1) {
          output.print( (relief_outer[t_x][0]) + " ");
        }
      }
      output.println(" ");//*/

      boolean completeLoop = false;
      boolean closedOut = true;
      boolean closedIn = true;

      int counter = 0;

      int prev_o = -1;
      int prev_i = -1;
      int land_o = -1;
      int land_i = -1;

      while (!(completeLoop && closedOut && closedIn)) {
        if (closedOut) {
          if (relief_outer[counter][0] == -1 && prev_o != -1) {
            closedOut = false;
          } else if (relief_outer[counter][0] != -1 && land_o == -1) {
            prev_o = relief_outer[counter][0];
          }
        }
        if (closedIn) {
          if (relief_inner[counter][0] == -1 && prev_i != -1) {
            closedIn = false;
          } else if (relief_inner[counter][0] != -1 && land_i == -1) {
            prev_i = relief_inner[counter][0];
          }
        } else if (!closedOut || !closedIn) {
          if (relief_outer[counter][0] != -1) {
            land_o = relief_outer[counter][0];
            closedOut = true;
          }
          if (relief_inner[counter][0] != -1) {
            land_i = relief_inner[counter][0];
            closedIn = true;
          }

          if (closedOut && closedIn) {
            output.println("f "+(prev_o)+" "+(prev_i)+" "+(land_o));
            output.println("f "+(prev_i)+" "+(land_i)+" "+(land_o));
            prev_o = land_o;
            prev_i = land_i;
            land_o = -1;
            land_i = -1;
          }
        }
        counter++;
        if (counter >= sides) {
          counter = 0; 
          completeLoop = true;
        }
      }
    } else { //// connect outer to inner at top
      for (int t_x = 0; t_x < sides; t_x++) {
        int o1 = relief_outer[t_x][0];
        int i1 = relief_inner[t_x][0];
        if (o1 != -1 && i1 != -1) {
          if (t_x<sides-1) {
            int o2 = relief_outer[t_x+1][0];
            int i2 = relief_inner[t_x+1][0];
            if (o2 != -1 && i2 != -1) {
              output.println("f "+(o1)+" "+(o2)+" "+(i1));
              output.println("f "+(i1)+" "+(o2)+" "+(i2));
            }
          } else {
            int o2 = relief_outer[0][0];
            int i2 = relief_inner[0][0];
            if (o2 != -1 && i2 != -1) {
              output.println("f "+(o1)+" "+(o2)+" "+(i1));
              output.println("f "+(i1)+" "+(o2)+" "+(i2));
            }
          }
        }
      }
    }//*/

    ////// TIE OUTER AND INNER AT BOTTOM
    if (!hollowBottom) {

      /// inner
      output.print("f ");
      for (int t_x = 0; t_x < sides; t_x++) {
        if (relief_inner[t_x][innerPts.size()-1] != -1) {
          output.print( (relief_inner[t_x][innerPts.size()-1]) + " ");
        }
      }
      output.println(" ");


      // outer
      output.print("f ");
      for (int t_x = sides-1; t_x >= 0; t_x--) {
        if (relief_outer[t_x][outerPts.size()-1] != -1) {
          output.print( (relief_outer[t_x][outerPts.size()-1]) + " ");
        }
      }
      output.println(" ");//*/


      boolean completeLoop = false;
      boolean closedOut = true;
      boolean closedIn = true;

      int counter = 0;

      int prev_o = -1;
      int prev_i = -1;
      int land_o = -1;
      int land_i = -1;

      while (!(completeLoop && closedOut && closedIn)) {
        if (closedOut) {
          if (relief_outer[counter][outerPts.size()-1] == -1 && prev_o != -1) {
            closedOut = false;
          } else if (relief_outer[counter][outerPts.size()-1] != -1 && land_o == -1) {
            prev_o = relief_outer[counter][outerPts.size()-1];
          }
        }
        if (closedIn) {
          if (relief_inner[counter][innerPts.size()-1] == -1 && prev_i != -1) {
            closedIn = false;
          } else if (relief_inner[counter][innerPts.size()-1] != -1 && land_i == -1) {
            prev_i = relief_inner[counter][innerPts.size()-1];
          }
        } else if (!closedOut || !closedIn) {
          if (relief_outer[counter][outerPts.size()-1] != -1) {
            land_o = relief_outer[counter][outerPts.size()-1];
            closedOut = true;
          }
          if (relief_inner[counter][innerPts.size()-1] != -1) {
            land_i = relief_inner[counter][innerPts.size()-1];
            closedIn = true;
          }

          if (closedOut && closedIn) {
            output.println("f "+(prev_o)+" "+(land_o)+" "+(prev_i));
            output.println("f "+(prev_i)+" "+(land_o)+" "+(land_i));
            prev_o = land_o;
            prev_i = land_i;
            land_o = -1;
            land_i = -1;
          }
        }
        counter++;
        if (counter >= sides) {
          counter = 0; 
          completeLoop = true;
        }
      }
    } else { // connect outer to inner at bottom

      for (int t_x = 0; t_x < sides; t_x++) {
        int o1 = relief_outer[t_x][outerPts.size()-1];
        int i1 = relief_inner[t_x][innerPts.size()-1];
        if (o1 != -1 && i1 != -1) {
          if (t_x<sides-1) {
            int o2 = relief_outer[t_x+1][outerPts.size()-1];
            int i2 = relief_inner[t_x+1][innerPts.size()-1];
            if (o2 != -1 && i2 != -1) {
              output.println("f "+(o1)+" "+(i1)+" "+(o2));
              output.println("f "+(i1)+" "+(i2)+" "+(o2));
            }
          } else {
            int o2 = relief_outer[0][outerPts.size()-1];
            int i2 = relief_inner[0][innerPts.size()-1];
            if (o2 != -1 && i2 != -1) {
              output.println("f "+(o1)+" "+(i1)+" "+(o2));
              output.println("f "+(i1)+" "+(i2)+" "+(o2));
            }
          }
        }
      }
    }//*/



    printSides(outerPts, innerPts, relief_outer, relief_inner, sides);
    if(sideVisTurnedOn){
    

    sideVisualizer.save("visualizer.png");
  }

    src.updatePixels();
  }
}

/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
float steps_distFromTop = 35;
float steps_orbSize = 30;
float steps_innerOrbSize = steps_orbSize-5;
float steps_inBetween = 150;
float steps_center = 450;
int selected = color(255, 255, 255);
int not_selected = color(107, 191, 236);
int not_selected_hover = color(177, 230, 245);

public void showSteps(int cStep) { 
  blendMode(BLEND);
  ellipseMode(CENTER);
  textAlign(CENTER);
  noStroke();

  stepOrb(1, steps_center-steps_inBetween, steps_distFromTop+steps_orbSize, cStep, "3D shape");
  stepOrb(2, steps_center, steps_distFromTop+steps_orbSize, cStep, "texture");
  stepOrb(3, steps_center+ steps_inBetween, steps_distFromTop+steps_orbSize, cStep, "size");

  arrow(steps_center-(steps_inBetween/2), steps_distFromTop+steps_orbSize);
  arrow(steps_center+(steps_inBetween/2), steps_distFromTop+steps_orbSize);
}

public void stepOrb(int t, float transX, float transY, int cStep, String txt) {

  int c;
  if (cStep == t) {  
    c = selected;
  } else if (PVector.dist(new PVector(transX, transY), new PVector(mouseX, mouseY)) <  steps_orbSize) { 
    c =not_selected_hover;
  } else {  
    c =not_selected;
  }
  fill(c);
  ellipse(transX, transY, steps_orbSize*2, steps_orbSize*2);
  fill(backgroundColor);
  ellipse(transX, transY, steps_innerOrbSize*2, steps_innerOrbSize*2);
  fill(c);
  textSize(steps_innerOrbSize*2);
  text(t, transX, transY+(steps_innerOrbSize*.7f));
  textSize(steps_innerOrbSize*.5f);
  text(txt, transX, transY-(steps_innerOrbSize*1.5f));
}

public void arrow(float transX, float transY) {
  // pushMatrix();
  // translate(transX, transY);
  strokeWeight(steps_orbSize - steps_innerOrbSize);
  stroke(not_selected);
  line(transX-20, transY, transX, transY);
  line(transX, transY-15, transX+15, transY);
  line(transX, transY+15, transX+15, transY);
  // popMatrix();
}



/////////////////////////
/////////////////////////

public void step0() {
  textAlign(CENTER);
  textSize(steps_innerOrbSize*2);
  fill(255);
  textSize(32);
  text("Welcome to LithoBox", width/2, 250);
  textSize(16);
  text("Here, you will be able to make\n 3D printable-lithophanes in 3 easy steps", width/2, 300);
  for (int i=0; i<stepButtons_0.size(); i++) {
    stepButtons_0.get(i).render(true);
  }
}
/////////////////////////
/////////////////////////
PImage drawingBox; // dimensions 3x4
PImage drawnBoxSave = new PImage(100, 100);
float dB_x = 450;
float dB_y = 120;
float dB_wid = 450;
float dB_hei = 300;
Boolean drawnInBox = false;


public void step1() {
  for (int i=0; i<stepButtons_1.size(); i++) {
    stepButtons_1.get(i).render(true);
  }
  image(drawingBox, dB_x, dB_y, dB_wid, dB_hei);
  pushMatrix();
  translate(width, 0);
  scale(-1, 1);
  image(drawingBox, dB_x, dB_y, dB_wid, dB_hei);
  popMatrix();
  fill(200);
  text("Templates", 100, 450);

  // fill(200);
  textSize(steps_innerOrbSize*.5f);
  text("(.gif, .jpg, .tga, or .png)", 435, 565);

  instructionBox();
}

/////////////////////
  
float whiteX;//  = (23.0 /  vaseHEIGHT_inches.getNumberMilimeters()) * drawingBox.height;/// 23 mm scaled to hightcv
////////////////////

float radiusOfBottom = 1.25f; //inches
public Boolean checkThicknessDraw(int x, int y) {
  if (y<100) {
    float t = map(y, 0, 100,  0, whiteX);
    if ( x<t  ) {
      return true;
    } else {
      return false;
    }
  } else if (y<(drawingBox.height-50)) {
    if (x<whiteX) {
      return true;
    } else {
      return false;
    }
  } else {
    if (x<((radiusOfBottom*drawingBox.height)/vaseHEIGHT_inches.getNumberInches())-(drawingBox.height-y)) {
      return true;
    } else {
      return false;
    }
  }
}

public Boolean checkBaseOuterThickness(int x, int y) {
  if (y>=(drawingBox.height-50)) {
    if (x>1+((radiusOfBottom*drawingBox.height)/vaseHEIGHT_inches.getNumberInches())+(2*(drawingBox.height-y))) {
      return false;
    }
  }

  return true;
}

public void checkThickness_uploadedImage() {        

  
  drawingBox.loadPixels();
  for (int y=0; y<drawingBox.height; y++) {
    if (y<100) {
      for (int x=0; x<=(y/3); x++) {
        if ( x<100) {
          int loc = (x) + (y)*drawingBox.width;
          drawingBox.pixels[loc] =  color(255);
        }
      }
    } else if (y<(drawingBox.height-50)) {  
      for (int x=0; x<=whiteX; x++) {
        int loc = (x) + (y)*drawingBox.width;
        drawingBox.pixels[loc] =  color(255);
      }
      
      
      
    } else {
      for (int x=0; x<((radiusOfBottom*drawingBox.height)/vaseHEIGHT_inches.getNumberInches())-(drawingBox.height-y); x++) {
        int loc = (x) + (y)*drawingBox.width;
        drawingBox.pixels[loc] =  color(255);
      }
      for (int x=PApplet.parseInt(1+((radiusOfBottom*drawingBox.height)/vaseHEIGHT_inches.getNumberInches())+(2*(drawingBox.height-y))); x>drawingBox.width; x++) {
        int loc = (x) + (y)*drawingBox.width;
        drawingBox.pixels[loc] =  color(0);
      }
      
    
      
  
        
        
    }
  }
  drawingBox.updatePixels();
}


public void checkThickness_drawnImage() {
  
  int xForClosestPartOfVaseResize = -1;
  drawingBox.loadPixels();
  for (int y=0; y<drawingBox.height; y++) {
    if (y<100) {
      for (int x=0; x<=30; x++) {
        int loc = (x) + (y)*drawingBox.width;
        drawingBox.pixels[loc] =  color(255);
      }
    } else if (y<(drawingBox.height-50)) {
      for (int x=0; x<whiteX; x++) {
        int loc = (x) + (y)*drawingBox.width;
        drawingBox.pixels[loc] =  color(255);
      }
      if(STAGE == 3 && y==(drawingBox.height-51)){
        int litX = 0;
        while(xForClosestPartOfVaseResize == -1 && litX < drawingBox.width){
          int loc = (litX) + (y)*drawingBox.width;
          float col = red(drawingBox.pixels[loc]);
          if(col < 127){ xForClosestPartOfVaseResize = litX; }
          litX++;
        }
        if(xForClosestPartOfVaseResize == -1){xForClosestPartOfVaseResize = drawingBox.width-1;}
      }
    } else {
      float b = ((radiusOfBottom*drawingBox.height)/vaseHEIGHT_inches.getNumberInches())-(drawingBox.height-y);
      if (b >= drawingBox.width) { 
        b =drawingBox.width;
      }
      for (int x=0; x<b; x++) {
        int loc = (x) + (y)*drawingBox.width;
        drawingBox.pixels[loc] =  color(255);
      }
      if (drawingBox.width > PApplet.parseInt(1+((radiusOfBottom*drawingBox.height)/vaseHEIGHT_inches.getNumberInches())+(2*(drawingBox.height-y)))) {
        for (int x=PApplet.parseInt(1+((radiusOfBottom*drawingBox.height)/vaseHEIGHT_inches.getNumberInches())+(2*(drawingBox.height-y))); x<drawingBox.width; x++) {
          int loc = (x) + (y)*drawingBox.width;
          drawingBox.pixels[loc] =  color(0);
        }
      }

      if (STAGE == 3) {
        int whiteBorder = PApplet.parseInt((radiusOfBottom*drawingBox.height)/vaseHEIGHT_inches.getNumberInches())-(drawingBox.height-y);
        int blackBorder = PApplet.parseInt(1+((radiusOfBottom*drawingBox.height)/vaseHEIGHT_inches.getNumberInches())+(2*(drawingBox.height-y)));
        if (whiteBorder < drawingBox.width) {
          if (blackBorder >= drawingBox.width) { 
            blackBorder = drawingBox.width;
          }
          for (int x=whiteBorder; x<blackBorder; x++) {
            int loc = (x) + (y)*drawingBox.width;
            if(x < xForClosestPartOfVaseResize){
            drawingBox.pixels[loc] =  color(255);
            }else{
            drawingBox.pixels[loc] =  color(0);  
            }
          }
        }
      }
    }
  }
  drawingBox.updatePixels();
}


public void proportionDrawingBox() {
  drawnInBox = false;

  PImage back = drawingBox.get();
  drawingBox.resize(PApplet.parseInt( PApplet.parseFloat(drawingBox.height) * (dB_wid/dB_hei)), drawingBox.height);
  
  whiteX  = (9.0f /  vaseHEIGHT_inches.getNumberMilimeters()) * drawingBox.height;
  println(vaseHEIGHT_inches.getNumberMilimeters());

  drawingBox.loadPixels();
  back.loadPixels();


  // determine if left size is black (assuming 2 sided vase)
  // or white (assuming 1 sided vase)
  int sidePos = drawingBox.width * 50;
  float average = (red(drawingBox.pixels[sidePos])+green(drawingBox.pixels[sidePos])+blue(drawingBox.pixels[sidePos]))/3;
  // println(average);
  if (average > 127) {  // if WHITE
    boolean negativeSpace = false;

    for (int y = 0; y < drawingBox.height; y++) {
      for (int x = 0; x < drawingBox.width; x++) {
        int c;
        if (x<back.width && negativeSpace == false) {
          int bacloc = (x) + (y)*back.width;
          float r = red(back.pixels[bacloc]);
          float g = green(back.pixels[bacloc]);
          float b = blue(back.pixels[bacloc]);
          float a = (r+g+b)/3;
          if (a<(255/2)) { 
            a=0;
            negativeSpace = true;
          } else {  
            a=255;
          }
          c = color(a);
        } else {
          c = color(0);
        }
        int loc = (x) + (y)*drawingBox.width;
        drawingBox.pixels[loc] =  c;
      }
      negativeSpace = false;
    }
  } else {  // if BLACK

    // determine if point at opposite side is white
    sidePos = drawingBox.width-1;
    average = (red(drawingBox.pixels[sidePos])+green(drawingBox.pixels[sidePos])+blue(drawingBox.pixels[sidePos]))/3;

    if (average > 127) {


      boolean negativeSpace = false;

      for (int y = 0; y < drawingBox.height; y++) {
        for (int x = 0; x < drawingBox.width; x++) {
          int c;
          if (x<back.width && negativeSpace == false) {
            int bacloc = (back.width-1-x) + (y)*back.width;
            float r = red(back.pixels[bacloc]);
            float g = green(back.pixels[bacloc]);
            float b = blue(back.pixels[bacloc]);
            float a = (r+g+b)/3;
            if (a<(255/2)) { 
              a=0;
              negativeSpace = true;
            } else {  
              a=255;
            }
            c = color(a);
          } else {
            c = color(0);
          }
          int loc = (x) + (y)*drawingBox.width;
          drawingBox.pixels[loc] =  c;
        }
        negativeSpace = false;
      }
    } else { // we're assuming whole vase, symmetrical, is being displayed


      boolean negativeSpace = false;

      for (int y = 0; y < drawingBox.height; y++) {
        for (int x = 0; x < drawingBox.width; x++) {
          int c;
          if (x<(back.width/2) && negativeSpace == false) {
            int bacloc = (x+(back.width/2)) + (y)*back.width;
            float r = red(back.pixels[bacloc]);
            float g = green(back.pixels[bacloc]);
            float b = blue(back.pixels[bacloc]);
            float a = (r+g+b)/3;
            if (a<(255/2)) { 
              a=0;
              negativeSpace = true;
            } else {  
              a=255;
            }
            c = color(a);
          } else {
            c = color(0);
          }
          int loc = (x) + (y)*drawingBox.width;
          drawingBox.pixels[loc] =  c;
        }
        negativeSpace = false;
      }
    }
  }


  drawingBox.updatePixels();
  drawingBox.resize(PApplet.parseInt( PApplet.parseFloat(600) * (dB_wid/dB_hei)), 600);
  checkThickness_uploadedImage();
  //drawingBox.save("ss.jpg");
}

public void drawInBox1() {
  float xDist = abs(mouseX - dB_x);
  float yDist = mouseY - dB_y;
  int xPos  = PApplet.parseInt( PApplet.parseFloat(drawingBox.width) * (xDist / dB_wid));
  int yPos  = PApplet.parseInt( PApplet.parseFloat(drawingBox.height) * (yDist / dB_hei));
  if (xPos >=0 && xPos < drawingBox.width && yPos >=0 && yPos < drawingBox.height) {
    drawnInBox = true;
    changesMade = true;
    int yWidth = PApplet.parseInt(8*  PApplet.parseFloat(drawingBox.width)/dB_wid);
    int upperY = yPos -yWidth;
    if (upperY < 0) { 
      upperY = 0;
    }
    int lowerY = yPos +yWidth;
    if (lowerY >= drawingBox.height) { 
      lowerY = drawingBox.height-1;
    }

    drawingBox.loadPixels();
    for (int y=upperY; y<lowerY; y++) {
      // int curntY;
      for (int x=0; x<drawingBox.width; x++) {
        int loc = (x) + (y)*drawingBox.width;
        int c;
        if ((x <= (xPos-abs((y-((lowerY+upperY)/2))/4)) || (checkThicknessDraw(x, y))) && checkBaseOuterThickness(x, y)) {
          c = color(255);
        } else {
          c = color(0);
        }
        drawingBox.pixels[loc] =  c;
      }
    }
    drawingBox.updatePixels();
  }
}
/////////////////////////
/////////////////////////
PImage step2ExampleSrcImg;
PImage step2ExampleVaseImg;
Boolean changesMade = true;
Boolean outerImageWhite = true;
Boolean innerImageWhite = true;

public void step2() {
  drawPreview(.003f);
  for (int i=0; i<stepButtons_2.size(); i++) {
    boolean b = true;
    if (i==1 && !outerImageWhite) { 
      b = false;
    } else if (i==2 && !innerImageWhite) { 
      b = false;
    }
    stepButtons_2.get(i).render(b);
  }
  fill(200);
  text("Selected images must be in \n format .gif, .jpg, .tga, or .png", 150, 300);
  image(step2ExampleSrcImg, 105, 350, 90, 45);
  // strokeWeight(steps_orbSize - steps_innerOrbSize);
  // stroke(not_selected);
  float transX = 150;
  float transY = 430;
  line(transX, transY-20, transX, transY);
  line(transX, transY+15, transX-15, transY);
  line(transX, transY+15, transX+15, transY);
  image(step2ExampleVaseImg, 0, 460);

  instructionBox();
}

public void updatePreviewVase() {
  PGraphics p = createGraphics(250, 100, P2D);
  PImage srcTexture = step2ExampleSrcImg.get();
  srcTexture.resize(200, 100);
  PImage srcShape = drawingBox.get();
  srcShape.resize(150, 100);
  srcShape.loadPixels();

  p.beginDraw();
  p.noStroke();
  p.fill(255);
  for (int y=0; y<p.height; y++) {
    int w = 0;
    for (int x=0; x<srcShape.width; x++) {
      int loc = x + y*srcShape.width;
      if (red(srcShape.pixels[loc]) < 127) {
        w = x;
        break;
      }
    }

    float left = ((srcShape.width-w));
    float right = ((srcShape.width-w)+(w*2)) ;


    p.beginShape();
    p.texture(srcTexture);
    p.vertex( left, y, 50, y);
    p.vertex(  right, y, 150, y);
    p.vertex( left, y+1, 50, y+1);
    p.endShape();  

    p.beginShape();
    p.texture(srcTexture);
    p.vertex(  right, y, 150, y);
    p.vertex( left, y+1, 50, y+1);
    p.vertex( right, y+1, 150, y+1);
    p.endShape();
  }
  p.endDraw();
  step2ExampleVaseImg = p.get();
  // step2ExampleVaseImg.save("ddd.png");
}

/////////////////////////
/////////////////////////

Boolean saveScreenUp = false;
String saveStep = "";
int delay = 0;

boolean changesMadeStep3 = false;
public void step3() {


  float wP = 180;
  float hP = 180;
  line(wP, 150, 450-(outline_width)/2, 150);
  line(wP, 150+outline_height, 450-(outline_width)/2, 150+outline_height);
  line(wP, 150, wP, 270);
  line(wP, 150+outline_height, wP, 360);
  line(450-(outline_width)/2, 150+outline_height, 450-(outline_width)/2, hP+outline_height);
  line(450+(outline_width)/2, 150+outline_height, 450+(outline_width)/2, hP+outline_height);
  line(450-(outline_width)/2, hP+outline_height, 400, hP+outline_height);
  line(450+(outline_width)/2, hP+outline_height, 500, hP+outline_height);
  if(changesMadeStep3) {
      
      checkThickness_drawnImage();
       loadPreview();
       changesMadeStep3 = false;
  
  }
  drawPreview(0.0f);
  vaseHEIGHT_inches.render();
  vaseWIDTH_inches.render();


  for (int i=0; i<stepButtons_3.size(); i++) {
    stepButtons_3.get(i).render(true);
  }

  if (saveScreenUp) {
    rect(200, 150, width-400, height-300);
    fill(selected);
    textSize(30);
    if (saveStep == "saved") {
      text("SAVED!", width/2, 200);
      fill(backgroundColor);
      textSize(15);
      text("Your file has been exported as: "+mostRecentName+".obj", width/2, 260);
      text("You can either exit now or continue to make changes", width/2, 300);
      for (int i=0; i<saveButtons.size(); i++) {
        saveButtons.get(i).render(true);
      }
    } else if (saveStep == "saving") {
      text("SAVING...", width/2, 200);
      delay++;
    }
  }

  instructionBox();
}


public void displayScaler() {
}

/////////////////////////
/////////////////////////

public void fileSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    if (STAGE == 2) {
      if (stepButtons_2.get(1).clicked == true) {
        stepButtons_2.get(1).clicked = false;
        String ending = (selection.getAbsolutePath()).substring(selection.getAbsolutePath().length()-4);
        if (ending.equals(".jpg") || ending.equals("jpeg") || ending.equals(".JPG") || ending.equals(".gif") ||  ending.equals(".tga") || ending.equals(".png") ) {
          println("User selected " + selection.getAbsolutePath());
          img1 = selection.getAbsolutePath();
          newOuterPreviewImg = true;
          outerImageWhite = false;
          loadPreview();
        }
      } else if (stepButtons_2.get(2).clicked == true) {
        stepButtons_2.get(2).clicked = false;
        String ending = (selection.getAbsolutePath()).substring(selection.getAbsolutePath().length()-4);
        if (ending.equals(".jpg") || ending.equals("jpeg") || ending.equals(".JPG") || ending.equals(".gif") ||  ending.equals(".tga") || ending.equals(".png") ) {
          println("User selected " + selection.getAbsolutePath());
          img2 = selection.getAbsolutePath();
          newInnerPreviewImg = true;
          innerImageWhite = false;
          loadPreview();
        }
      }
    } else if (STAGE==1 && stepButtons_1.get(5).clicked == true) {
      stepButtons_1.get(5).clicked = false;
      String ending = (selection.getAbsolutePath()).substring(selection.getAbsolutePath().length()-4);
      if (ending.equals(".jpg") || ending.equals("jpeg") ||  ending.equals(".JPG") || ending.equals(".gif") ||  ending.equals(".tga") || ending.equals(".png") ) {
        println("User selected " + selection.getAbsolutePath());
        // figure out how to turn image into example image
        if (drawnInBox) {  
          drawnBoxSave = drawingBox.get();  
          set4thBox();
        }
        drawingBox = loadImage(selection.getAbsolutePath());
        // drawingBox = greyscale(drawingBox);
        proportionDrawingBox();
        changesMade = true;
    
      }
    }
  }
}

//////////////////////////

////instruction box

String instruction1  = "Select shape of lithophane. Shapes can also be drawn in program by clicking and dragging on the image.";
String instruction2 = "Select inner and outer image to be displayed on lithophane. Inner image will appear blurrier and will not be visible when there is not a light source inside the 3D model.";
String instruction3 = "Size model for 3D printing. The intended size of the model will affect how thick the walls of the 3D model will be.";

public void instructionBox() {

  String s;
  if (STAGE == 1) {
    s = instruction1;
  } else if (STAGE == 2) {
    s = instruction2;
  } else {
    s = instruction3;
  }

  fill(255);
  textSize(14);
  text(s, width*36/48, 25, 200, 300);
}

/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
class inchScale {

  float xPos;
  float yPos;
  ArrayList<BoxButton> arrows;
  String txt;
  int textSizeWords = 16;
  int textSizeNumbers = 32;


  IntList digits = new IntList();


  inchScale(float x, float y, String t, float startingValue) {
    xPos = x;
    yPos = y;
    txt = t;

    arrows = new ArrayList<BoxButton>();
    arrows.add(new BoxButton(xPos-55, yPos-40, 30, 17, "1", 21, true));
    arrows.add(new BoxButton(xPos-15, yPos-40, 30, 17, ".1", 21, true));
    arrows.add(new BoxButton(xPos+25, yPos-40, 30, 17, ".01", 21, true));
    arrows.add(new BoxButton(xPos-55, yPos+40, 30, 17, "1", 22, true));
    arrows.add(new BoxButton(xPos-15, yPos+40, 30, 17, ".1", 22, true));
    arrows.add(new BoxButton(xPos+25, yPos+40, 30, 17, ".01", 22, true));

    setNumbers(startingValue);
  }

  public void setNumbers(float v) {
    digits.set(0, PApplet.parseInt(v));
    digits.set(1, PApplet.parseInt((v*10) % 10));
    digits.set(2, PApplet.parseInt((v*100) % 10));
  }

  public float getNumberInches() {
    float d = PApplet.parseFloat(digits.get(0)) + (PApplet.parseFloat(digits.get(1))/10) + (PApplet.parseFloat(digits.get(2))/100);
    return d;
  }

  public float getNumberMilimeters() {
    float d = 25.4f * (PApplet.parseFloat(digits.get(0)) + (PApplet.parseFloat(digits.get(1))/10) + (PApplet.parseFloat(digits.get(2))/100));
    return d;
  }

  public void addOrSubtract(int digi, int direction) {
    digits.set(digi, digits.get(digi) + direction );

    if (digits.get(digi) > 9 ) {
      if (digi == 0) {  
        digits.set(digi, 9);
      } else { 
        digits.set(digi, digits.get(digi)-10);
        if (digi > 0) {
          addOrSubtract(digi-1, direction);
        }
      }
    } else if (digits.get(digi) < 0 ) {
    
        digits.set(digi, digits.get(digi)+10);
      if (digi > 0) {
        addOrSubtract(digi-1, direction);
      }
     
    }
  }

  public Boolean mouseOver() {  
    if (mouseX > xPos-55 && mouseX < xPos+55 && mouseY > yPos-40 && mouseY < yPos+57) {
      return true;
    } else {
      return false;
    }
  }


  public void render() {

    for (int i=0; i<arrows.size(); i++) {
      arrows.get(i).render(true);
    }
    fill(200);
    textSize(textSizeWords);
    text(txt, xPos+100, yPos+0);
    textSize(textSizeNumbers);
    text(digits.get(0), xPos-40, yPos+20);
    text(digits.get(1), xPos, yPos+20);
    text(digits.get(2), xPos+40, yPos+20);
    text(".", xPos-20, yPos+20);
  }
}

inchScale vaseHEIGHT_inches;
inchScale vaseWIDTH_inches;


public void setupInchScales() {
  vaseHEIGHT_inches = new inchScale(125, 300, "height\n(inches)", 4.50f);
  vaseWIDTH_inches = new inchScale(450, 520, "width\n(inches)", 2.98f);
}


public void setWIDTHbasedOnHEIGHT(Boolean rescaleVase) {
  float tmp = vaseHEIGHT_inches.getNumberInches() * (outline_width/outline_height);
  if (tmp < 10) {
    vaseWIDTH_inches.setNumbers(tmp);
  } else {
    vaseWIDTH_inches.setNumbers(9.99f);
    setHEIGHTbasedOnWIDTH(rescaleVase);
  }
  if (rescaleVase) {  
    changesMadeStep3 = true;
  }
}

public void setHEIGHTbasedOnWIDTH(Boolean rescaleVase) {

  float tmp = vaseWIDTH_inches.getNumberInches() * (outline_height/outline_width);
  if (tmp < 10) {
    vaseHEIGHT_inches.setNumbers(tmp);
  } else {
    vaseHEIGHT_inches.setNumbers(9.99f);  
    setWIDTHbasedOnHEIGHT(rescaleVase);
  }
  if (rescaleVase) {  
    changesMadeStep3 = true;
  }
}

/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
boolean newOuterPreviewImg = true;
boolean newInnerPreviewImg = true;


float outline_height;
float outline_width;

public void loadPreview() {

  if (newOuterPreviewImg) {
    outerPreview = loadImage(img1);
    outerSurface = outerPreview.get(); 
 
    outerPreview.resize( PApplet.parseInt(previewResolution*(PApplet.parseFloat(outerPreview.width)/PApplet.parseFloat(outerPreview.height))), previewResolution);
    outerPreview = greyscale(outerPreview);
    newOuterPreviewImg= false;
  }
  if (newInnerPreviewImg) {
    innerPreview = loadImage(img2);
    innerSurface = innerPreview.get();
     
    innerPreview.resize( PApplet.parseInt(previewResolution*(PApplet.parseFloat(innerPreview.width)/PApplet.parseFloat(innerPreview.height))), previewResolution);
    int iw = innerPreview.width;
    int ih = innerPreview.height;
    int scaleDown = 4;
    innerPreview.resize(innerPreview.width/scaleDown, innerPreview.height/scaleDown);
    innerPreview.resize(iw, ih);
    innerPreview = greyscale(innerPreview);
    newInnerPreviewImg = false;
  }

  outlinePreview = new ArrayList<PVector>();

  PImage src;
  if (drawingBox == null) {
    src = loadImage(image_name);
  } else {
    src = drawingBox.get();
  }
  src.loadPixels(); 

  int rows = src.width;
  int cols = src.height;

  int scaleRes = PApplet.parseInt ( PApplet.parseFloat(cols) / PApplet.parseFloat(previewResolution) );


  outline_height = PApplet.parseFloat(cols) / PApplet.parseFloat(scaleRes);
  outline_width = 0;


  ////// GENERATE POINTS FOR OUTER VASE
  //  int actualCols_outer = 0;
  int previous = -1; // -1 if no data, 0 if black (less than 127), 1 if white (more than 127)
  for (int pic_y = 0; pic_y < cols; pic_y+=scaleRes) {
    for (int pic_x = 0; pic_x < rows; pic_x++) {

      int src_loc = (pic_x) + (pic_y)*(src.width);

      float r = red(src.pixels[src_loc]);
      float g = green(src.pixels[src_loc]);
      float b = blue(src.pixels[src_loc]);

      float c = (r+g+b)/(255*3); // gets to greyscale between 0 and 1

      if (c<.5f && previous == 1) {
        // used to - generate ring based on pic_x as radius
        outlinePreview.add(new PVector(PApplet.parseFloat(pic_x)/PApplet.parseFloat(scaleRes), PApplet.parseFloat(pic_y)/PApplet.parseFloat(scaleRes)));
        if(2*(PApplet.parseFloat(pic_x)/PApplet.parseFloat(scaleRes)) > outline_width){
            outline_width = 2*(PApplet.parseFloat(pic_x)/PApplet.parseFloat(scaleRes));
        }
      }

      if (c>.5f) { 
        previous = 1;
      } else { 
        previous = 0;
      }
    }
    previous = -1;
  }
  
  setWIDTHbasedOnHEIGHT(false);
}


public PImage greyscale(PImage p) {

  p.loadPixels();
  for (int y = 0; y < p.height; y++) {
    for (int x = 0; x < p.width; x++) {
      int loc = (x) + (y)*p.width;
      float r = red(p.pixels[loc]);
      float g = green(p.pixels[loc]);
      float b = blue(p.pixels[loc]);
      float a = floor((r+g+b)/3);
      int c = color(a, a, a);
      p.pixels[loc] =  c;
    }
  }
  p.updatePixels();
  return p;
}






public void drawPreviewSection(ArrayList<PVector> oP, float a, float b, PImage img, float startPos, float endPos) {

  for (int i=0; i<oP.size()-1; i++) {  
    float left = map(a, 0, 1, -oP.get(i).x, oP.get(i).x);
    float right = map(b, 0, 1, -oP.get(i).x, oP.get(i).x);

    beginShape();
    texture(img);
    vertex( left, oP.get(i).y, startPos, img.height*(PApplet.parseFloat(i)/PApplet.parseFloat(oP.size())));
    vertex(  right, oP.get(i).y, endPos, img.height*(PApplet.parseFloat(i)/PApplet.parseFloat(oP.size())));
    vertex( left, oP.get(i+1).y, startPos, img.height*(PApplet.parseFloat(i+1)/PApplet.parseFloat(oP.size())));
    endShape();  

    beginShape();
    texture(img);
    vertex(  right, oP.get(i).y, endPos, img.height*(PApplet.parseFloat(i)/PApplet.parseFloat(outlinePreview.size())));
    vertex( left, oP.get(i+1).y, startPos, img.height*(PApplet.parseFloat(i+1)/PApplet.parseFloat(outlinePreview.size())));
    vertex( right, oP.get(i+1).y, endPos, img.height*(PApplet.parseFloat(i+1)/PApplet.parseFloat(outlinePreview.size())));
    endShape();
  }
}



//////////////////////////////////////////////////////////////////
int previewHeight = 300;
int previewResolution = 300;
float scaler = PApplet.parseFloat(previewHeight) / PApplet.parseFloat(previewResolution);

ArrayList<PVector> outlinePreview;
PImage outerPreview;
PImage innerPreview;

float rot_position = 0;
//float rotSpeed = .003;

//////////////////////////////////////////////////////////////////

public void drawPreview(float rotSpeed) {



  pushMatrix();
  translate(450, 150);



  noStroke();

  scale(scaler, scaler);

  fill(20);
  blendMode(SUBTRACT);
  float bottomY = outlinePreview.get(outlinePreview.size()-1).y;
  beginShape();
  for (int i=0; i<outlinePreview.size(); i++) {
    vertex( outlinePreview.get(i).x+(outlinePreview.size()-i), ((bottomY*2)+outlinePreview.get(i).y)/3);
  }
  for (int i=outlinePreview.size()-1; i>=0; i--) {
    vertex( (outlinePreview.size()-i)-outlinePreview.get(i).x, ((bottomY*2)+outlinePreview.get(i).y)/3);
  }
  endShape(); 

  fill(230);
  blendMode(ADD);
  beginShape();
  for (int i=0; i<outlinePreview.size(); i++) {
    vertex( outlinePreview.get(i).x, outlinePreview.get(i).y);
  }
  for (int i=outlinePreview.size()-1; i>=0; i--) {
    vertex( -outlinePreview.get(i).x, outlinePreview.get(i).y);
  }
  endShape();  

  blendMode(MULTIPLY);


  float startPos = rot_position * innerPreview.width;
  float endPos = rot_position + .5f;
  if (endPos >= 1) {  
    endPos -= 1;
  }
  endPos = endPos * innerPreview.width;

  // inner
  if (startPos < endPos) {
    drawPreviewSection(outlinePreview, 0, 1, innerPreview, startPos, endPos);
  } else {
    float d = ((innerPreview.width)-(2*(startPos-(innerPreview.width/2)))) / PApplet.parseFloat(innerPreview.width); 
    drawPreviewSection(outlinePreview, 0, d, innerPreview, startPos, innerPreview.width);
    drawPreviewSection(outlinePreview, d, 1, innerPreview, 0, endPos);
  }


  startPos = rot_position * outerPreview.width;
  endPos = rot_position + .5f;
  if (endPos >= 1) {  
    endPos -= 1;
  }
  endPos = endPos * outerPreview.width;

  // outer
  if (startPos < endPos) {
    drawPreviewSection(outlinePreview, 0, 1, outerPreview, startPos, endPos);
  } else {
    float d = ((outerPreview.width)-(2*(startPos-(outerPreview.width/2)))) / PApplet.parseFloat(outerPreview.width); 
    drawPreviewSection(outlinePreview, 0, d, outerPreview, startPos, outerPreview.width);
    drawPreviewSection(outlinePreview, d, 1, outerPreview, 0, endPos);
  }



  popMatrix();


  rot_position += rotSpeed;
  if (rot_position >= 1) {  
    rot_position -= 1;
  }
  blendMode(BLEND);
}

/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
public void printSides(ArrayList<PVector> outerPts, ArrayList<PVector> innerPts, int[][] relief_outer, int[][] relief_inner, int sides) {

  /// outer to inner scaler
  float oi_scaler = PApplet.parseFloat(outerPts.size())/PApplet.parseFloat(innerPts.size());

  /// SIDES
  for (int t_y = 0; t_y < outerPts.size(); t_y++) {
    for (int t_x = 0; t_x < sides; t_x++) {

      int curnt = relief_outer[t_x][t_y];
      if (curnt != -1) {
        ////////////  //////////  //////////  //////////  //////////  //////////      
        ////////////  //////////  //////////  //////////  //////////  //////////
        int toLeft;

        if (t_x > 0) {
          toLeft = t_x-1;
        } else {
          toLeft = sides-1; // if wraps around
        }


        int toRight;

        if (t_x < sides-1) {
          toRight = t_x+1;
        } else {
          toRight = 0; // if wraps around
        }

        PVector u1 = new PVector(t_x, t_y);
        if (t_y < outerPts.size()-1) {




          if (relief_outer[toLeft][t_y+1] != -1) {
            /// diagonal down to left
            int diag = relief_outer[toLeft][t_y+1];
            PVector u2 = new PVector(toLeft, t_y+1);
            if (relief_outer[t_x][t_y+1] == -1) { // down
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, diag, true);
            }
            if (relief_outer[toLeft][t_y] == -1) { // left
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, diag, false);
            }
          }



          if (relief_outer[toRight][t_y+1] != -1) { 
            //// diagonal down to right
            int diag = relief_outer[toRight][t_y+1];
            PVector u2 = new PVector(toRight, t_y+1);
            if (relief_outer[t_x][t_y+1] == -1) { // down
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, diag, false);
            }
            if (relief_outer[toRight][t_y] == -1) { // right
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, diag, true);
            }
          }

          /// down (check if t_x = 0 or t_x == rows-1)
          if (relief_outer[t_x][t_y+1] != -1) {
            int down = relief_outer[t_x][t_y+1];
            PVector u2 = new PVector(t_x, t_y+1);

            if (relief_outer[toRight][t_y] == -1 && relief_outer[toRight][t_y+1] == -1) {
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, down, true);
            } else if (relief_outer[toLeft][t_y] == -1 && relief_outer[toLeft][t_y+1] == -1) {
              findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, down, false);
            }
          }
        }


        if ( relief_outer[toRight][t_y] != -1) { 
          int right = relief_outer[toRight][t_y];
          PVector u2 = new PVector(toRight, t_y);

          if (t_y!=0 && relief_outer[t_x][t_y-1] == -1 && relief_outer[toRight][t_y-1] == -1) {
            findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, right, true);
          } else if (t_y < outerPts.size()-1 && relief_outer[t_x][t_y+1] == -1 && relief_outer[toRight][t_y+1] == -1) {
            findInner(relief_outer, relief_inner, oi_scaler, innerPts.size(), sides, u1, u2, curnt, right, false);
          }
        }


        ////////////  //////////  //////////  //////////  //////////  ////////// 
        ////////////  //////////  //////////  //////////  //////////  //////////**/
      }
    }
  }
}





public void findInner(int[][] relief_outer, int[][] relief_inner, float oi_scaler, int innerY, int sides, PVector u1, PVector u2, int p1, int p2, boolean dir) {
  // just find point closest to u1

  /////////////////////////////////////////////
  float closest = u1.y / oi_scaler;
  int c = 0;
  //  round closest up if > .5, down if less than .5
  // to left
  int tl = PApplet.parseInt(u1.x)-1;
  if (tl < 0) { 
    tl = sides-1;
  }
  // to right
  int tr = PApplet.parseInt(u1.x)+1;
  if (tr >= sides) { 
    tr = 0;
  }

  if (closest - PApplet.parseInt(closest) > .5f) {
    c = PApplet.parseInt(closest) +1;
    if (relief_inner[PApplet.parseInt(u1.x)][c] == -1) {
      while (relief_inner[PApplet.parseInt(u1.x)][c] == -1) { 
        c = c-1;
      }
    }
  } else {
    c = PApplet.parseInt(closest);
    if (relief_inner[PApplet.parseInt(u1.x)][c] == -1) {
      while (relief_inner[PApplet.parseInt(u1.x)][c] == -1) { 
        c = c+1;
      }
    }
  }

  // if none of the nearest are -1
  if (relief_inner[tl][c] != -1  && relief_inner[tr][c] != -1 &&
    (c==0 ||  relief_inner[PApplet.parseInt(u1.x)][c-1] != -1) &&
    (c==innerY-1 ||  relief_inner[PApplet.parseInt(u1.x)][c+1] != -1)  ) {

    ////// if c == 0, keep moving down until a hit
    if (c==0) {
      while (relief_inner[tl][c] != -1  && relief_inner[tr][c] != -1 &&
        (c==0 ||  relief_inner[PApplet.parseInt(u1.x)][c-1] != -1) &&
        relief_inner[PApplet.parseInt(u1.x)][c+1] != -1) {
        c++;
      }
    }

    /// if c == innerY -1, keep moving up until a hit
    else if (c==innerY-1) {
      while (relief_inner[tl][c] != -1  && relief_inner[tr][c] != -1 &&
        (c==0 ||  relief_inner[PApplet.parseInt(u1.x)][c-1] != -1) &&
        relief_inner[PApplet.parseInt(u1.x)][c-1] != -1) {
        c--;
      }
    }

    /// if c in the middle, test up and down until a hit
    else {
      boolean hitWallTop = false;
      boolean hitWallBottom = false;
      boolean found = false;
      int dist = 1;
      while (!found) {
        int _up = c-dist;
        if (_up < 0) {
          hitWallTop = true;
        }
        int _down = c+dist;
        if (_down > innerY-1) {
          hitWallBottom = true;
        }

        if (!hitWallTop &&
          relief_inner[tl][_up] != -1  && relief_inner[tr][_up] != -1 &&
          (_up-1 ==0 || relief_inner[tl][_up-1] != -1 )) {
          c = _up;
          found = true;
        } else if (!hitWallBottom &&
          relief_inner[tl][_down] != -1  && relief_inner[tr][_down] != -1 &&
          (_down ==innerY-1 || relief_inner[tl][_down+1] != -1 )) {
          c = _down;
          found = true;
        } else if (hitWallTop && hitWallBottom) { // if somehow you hit top and bottom, abort
          found = true;
        }
      }
    }
  }


  int p3 = relief_inner[PApplet.parseInt(u1.x)][c];


  if (dir) {
    output.println("f "+(p1)+" "+(p2)+" "+(p3));
  } else {
    output.println("f "+(p1)+" "+(p3)+" "+(p2));
  }
  //////////////////////////////////////////////
  int p4;
  if (u1.y == u2.y) { // if to the right, therefore knowing no height problem
    int toRight = PApplet.parseInt(u1.x)+1;
    int c2 = c;
    if (toRight >= sides) {  
      toRight = 0;
    }
    p4 = relief_inner[toRight][c2];
    if (dir) {
      while (p4==-1) {
        c2++;
        p4 = relief_inner[toRight][c2];
      }
      output.println("f "+(p2)+" "+(p4)+" "+(p3));
    } else {
      while (p4==-1) {
        c2--;
        p4 = relief_inner[toRight][c2];
      }
      output.println("f "+(p2)+" "+(p3)+" "+(p4));
    }
  }
  //////////////////////////////////////////////
  //////////////////////////////////////////////
  if (  oi_scaler*(c+1) <= u2.y+1.5f) { // if close enough with down sclaer

    //////////////////////////////////////////////
    //////////////////////////////////////////////
    if (u1.x == u2.x && u1.y != u2.y) {  // if straight down
      int c2 = c+1;
      int t=0;

      //if(dir){t++;}
      //  else{t--;}

      int t2 = PApplet.parseInt(u1.x + t);

      if (t2 >= sides) { 
        t2=0;
      } else if (t2 <0) { 
        t2=sides-1;
      }

      p4 = relief_inner[t2][c2];

      while (p4 == -1) {
        if (dir) {  
          t--;
        } else { 
          t++;
        }
        t2 = PApplet.parseInt(u1.x + t);
        if (t2 >= sides) { 
          t2=0;
        } else if (t2 <0) { 
          t2=sides-1;
        }
        p4 = relief_inner[t2][c2];
      }

      if (dir) {  
        output.println("f "+(p2)+" "+(p4)+" "+(p3));
      } else {   
        output.println("f "+(p2)+" "+(p3)+" "+(p4));
      }
    }
    //////////////////////////////////////////////
    //////////////////////////////////////////////
    //// if diagonal down to the left
    if ( u1.y != u2.y && (u1.x-1 == u2.x || (u1.x ==0 &&  u2.x == (sides-1)))) {  
      int c2 = c+1;
      int t = 0;


      if (dir) {
     //   t++;
      } else {
      //  t--;
      }

      int t2 = PApplet.parseInt(u2.x + t);

     /* if (t2 >= sides) { 
        t2=0;
      } else if (t2 <0) { 
        t2=sides-1;
      }//*/

      p4 = relief_inner[t2][c2];

      while (p4 == -1) {
        if (dir) {  
          t--;
        } else { 
          t++;
        }
        t2 = PApplet.parseInt(u2.x + t);
        if (t2 >= sides) { 
          t2=0;
        } else if (t2 <0) { 
          t2=sides-1;
        }
        p4 = relief_inner[t2][c2];
      }//*/

      if (dir) {  
        output.println("f "+(p2)+" "+(p4)+" "+(p3));
      } else {   
        output.println("f "+(p2)+" "+(p3)+" "+(p4));
      }
    }//*/


    //////////////////////////////////////////////
    //////////////////////////////////////////////
    ///// if diagonal down to the right

    if ( u1.y != u2.y && (u1.x+1 == u2.x || (u1.x ==(sides-1) &&  u2.x == 0))) {  
      int c2 = c+1;
      int t=0;

     /* if (dir) {
     //   t++;
      } else {
      //  t--;
      }//*/

      int t2 = PApplet.parseInt(u2.x + t);

      if (t2 >= sides) { 
        t2=0;
      } else if (t2 <0) { 
        t2=sides-1;
      }

      p4 = relief_inner[t2][c2];


      while (p4 == -1) {
        if (dir) {  
          t--;
        } else { 
          t++;
        }
        t2 = PApplet.parseInt(u2.x + t);
        if (t2 >= sides) { 
          t2=0;
        } else if (t2 <0) { 
          t2=sides-1;
        }
        p4 = relief_inner[t2][c2];
      }//*/

      if (dir) {  
        output.println("f "+(p2)+" "+(p4)+" "+(p3));
        if (relief_outer[PApplet.parseInt(u1.x)][PApplet.parseInt(u2.y)] != -1) { // fill in empty top and bot
          output.println("f "+(p1)+" "+(relief_outer[PApplet.parseInt(u1.x)][PApplet.parseInt(u2.y)])+" "+(p2));
        }
        if (relief_inner[PApplet.parseInt(u1.x)][c2] != -1) { // fill in empty top and bot
          output.println("f "+(p4)+" "+(relief_inner[PApplet.parseInt(u1.x)][c2])+" "+(p3));
        }
      } else {   
        output.println("f "+(p2)+" "+(p3)+" "+(p4));
        if (relief_outer[PApplet.parseInt(u2.x)][PApplet.parseInt(u1.y)] != -1) { // fill in empty top and bot
          output.println("f "+(p1)+" "+(p2)+" "+(relief_outer[PApplet.parseInt(u2.x)][PApplet.parseInt(u1.y)]));
        }
        if (relief_inner[PApplet.parseInt(u2.x)][c] != -1) { // fill in empty top and bot
          output.println("f "+(p3)+" "+(relief_inner[PApplet.parseInt(u2.x)][c])+" "+(p4));
        }
      }

    }//*/


    //////////////////////////////////////////////
    //////////////////////////////////////////////
  }//*/
  //////////////////////////////////////////////
  //////////////////////////////////////////////
}

/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
public PVector warp(PVector input, boolean outer) {  
  PVector output = new PVector(input.x, input.y, input.z);

  float originalY = output.y;


  // output example: test1.png, spiral2.png, cutThru.png
  // outer: 5, inner: 5
  /* output.x = changeByVar(output.x, originalY, .01);  
   output.z = changeByVar(output.z, originalY, .01);
   output = arcXbyY(output, 100, -.2, .03);
   output.z = moveByVar(output.z, originalY, .5);
   //*/


  // mary neubauer bronze sculpture /// sea life vase
  // test0.png, mbronze_cut, mbronze_out, mbronze_in,
  /// outer: 15, inner: 5
  /* if (originalY > 200) {
   output.x = changeByVar(output.x, originalY-200, -.003);  
   output.z = changeByVar(output.z, originalY-200, -.003);
   }
   if (originalY < 150) {
   output = flowerY(output, new PVector(50, 150), .005*(150-originalY) );
   output.y = rippleY(output, (150-originalY)/15, 8.0, 0);
   }//*/


/*
  // snake swallowing its own tail
  // test0.png, snakeSkin.png, snaketeeth.png, nocutout.png
  // outer: 5 inner: 15
  int g = 100;
  if (originalY < g) {
    output = flowerY(output, new PVector(50, g), .005*(g-originalY) );
    output.y = rippleY(output, (g-originalY)/15, 2.0, -PI/2);
  }
  int s1 = 0;
  int s2 = 100;
  if (outer && originalY >= s1 && originalY <= s2) {
    output = bulgeXZ(output, originalY, s1, 10, 30, s2, -PI/2, -PI/8, PI/8, PI/2, 30.0);
  }
  output = arcXbyY(output, 200, 0, .025);
  //*/ //*/



  // you're only ****ing yourself
  /*//test0.png, nocutout.png
   int g = 100;
   if (originalY < g) {
   output = flowerY(output, new PVector(50, g), .005*(g-originalY) );
   output.y = rippleY(output, (g-originalY)/15, 8.0, 0);
   }
   int s1 = 240;
  int s2 = 300;
  int mid = 260;
  if (outer && originalY >= s1 && originalY <= s2) {
    output = bulgeXZ(output, originalY, s1, mid, mid, s2, -PI, -PI, PI, PI, 30.0);
  }
   output = arcXbyY(output, 150, 0, .0225);
   //*/





  return output;
}



public float changeByVar(float x, float y, float s) {
  return (x / ((y*s)+1));
}

public float moveByVar(float x, float y, float s) {
  return (x + (y*s));
}

public PVector arcXbyY(PVector o, float radius, float radius_scaler, float a) {

  float angle = a * o.y;
  float mag = (radius+(radius_scaler*o.y)) + o.x;
  PVector p = PVector.fromAngle(angle);
  p.setMag(mag);

  o.x = p.x;
  o.y = p.y;

  return o;
}



public PVector flowerY(PVector o, PVector ro, float a ) {

  PVector o2 = new PVector(  sqrt(pow(o.x, 2)+pow(o.z, 2)) -ro.x, o.y-ro.y);
  o2.rotate(a);

  float xzheading = ( new PVector(o.x, o.z)  ).heading();
  PVector oxz = new PVector(o2.x +ro.x, 0);
  oxz.rotate(xzheading);

  o = new PVector( oxz.x, o2.y+ro.y, oxz.y);


  return o;
}



public float rippleY(PVector o, float scaler, float ripples, float trans) {

  float ang = (new PVector(o.x, o.z)).heading();
  float rip = sin(trans+(ang*ripples))*scaler;

  o.y += rip;

  return o.y;
}


//(output, s1, 75, 75, s2, PI*3/2, PI*7/8 , PI/8, PI/2 , 50.0);
public PVector bulgeXZ( PVector o, float posY, int start, int startMid, int endMid, int end, 
  float angStart, float angMaxStart, float angMaxEnd, float angEnd, 
  float bulgeAmount) {

  PVector xz = new PVector(o.x, o.z);
  float xzdir = xz.heading();

  float coefficient1 = 1;
  float coefficient2 = 0;

  // set coeffient 1, based on Y
  //////////////////////////////////////////////////////////////////
  if (posY >= start && posY <= startMid) {
    if (start == startMid) {
      coefficient1 = 1;
    } else {
      coefficient1 = (posY-start)/(startMid-start);
    }
  } else if (posY >= startMid && posY <= endMid) {
    coefficient1 = 1;
  } else if (posY >= endMid && posY <= end) {
    if (start == startMid) {
      coefficient1 = 1;
    } else {
      coefficient1 = 1-((posY-endMid)/(end-endMid));
    }
  }

  if (coefficient1<=.5f) {
    coefficient1 = (pow(coefficient1*2, 2))/2;
  } else {
    coefficient1 = 1-((pow((1-coefficient1)*2, 2))/2);
  }
  //////////////////////////////////////////////////////////////////

  // set coefficnet2 based on angle
  //////////////////////////////////////////////////////////////////
  // if normal
  if (angStart<=angMaxStart && angStart<=xzdir && xzdir<=angMaxStart) {
    if (angStart==angMaxStart) {
      coefficient2 = 1;
    } else {
      coefficient2 = (xzdir-angStart)/(angMaxStart-angStart);
    }
  }
  //if crosses median
  else if (angStart>angMaxStart && (xzdir>=angStart || xzdir<=angMaxStart)) {
    if (xzdir>=angStart) {  
      angMaxStart+=(2*PI);
    } else {  
      angStart-=(2*PI);
    }
    coefficient2 = (xzdir-angStart)/(angMaxStart-angStart);
  }
  // if normal middle
  else if (angMaxStart<=angMaxEnd && angMaxStart<=xzdir && xzdir<=angMaxEnd) {
    coefficient2 = 1;
  }
  //if crosses median
  else if (angMaxStart>angMaxEnd && (xzdir>=angMaxStart || xzdir<=angMaxEnd)) {
    coefficient2 = 1;
  }
  // normal
  else if (angMaxEnd<=angEnd && angMaxEnd<=xzdir && xzdir<=angEnd) {
    if (angMaxEnd==angEnd) {
      coefficient2 = 1;
    } else {
      coefficient2 = 1-((xzdir-angMaxEnd)/(angEnd-angMaxEnd));
    }
  }
  //if crosses median
  else if (angMaxEnd>angEnd && (xzdir>=angMaxEnd || xzdir<=angEnd)) {
    if (xzdir>=angMaxEnd) {  
      angEnd+=(2*PI);
    } else {  
      angMaxEnd-=(2*PI);
    }
    coefficient2 = 1-((xzdir-angMaxEnd)/(angEnd-angMaxEnd));
  }







  if (coefficient2<=.5f) {
    coefficient2 = (pow(coefficient2*2, 2))/2;
  } else {
    coefficient2 = 1-((pow((1-coefficient2)*2, 2))/2);
  }
  //////////////////////////////////////////////////////////////////

  float coefficient_full = coefficient1 * coefficient2;
  float newMag = xz.mag() + (coefficient_full * bulgeAmount);
  xz.setMag(newMag);
  o.x = xz.x;
  o.z = xz.y;




  return o;
}
  public void settings() {  size(900, 600, P2D); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--present", "--window-color=#666666", "--stop-color=#cccccc", "Lithobox2" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
