
/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
String session_name = "Lithobox Generated Models/";

int STAGE = 0;
// stage 1 outline
// stage 2 inners
// stage 3 export

void setup() {
  size(900, 600, P2D);
  setupBoxButtons();
  setupInchScales();
  loadPreview();
  drawingBox = loadImage("vase.png");
  proportionDrawingBox();
  
 // println(drawingBox.height);
}

int backgroundColor = 50;
boolean scaleExportInMilimeters = true; // inches or milimeters
void draw() {

  background(backgroundColor);

  showSteps(STAGE);
  if (STAGE == 0) {
    step0();
  } else if (STAGE == 1) {
    step1();
  } else if (STAGE == 2) {
    step2();
  } else {
    step3();
    if (saveScreenUp && saveStep == "saving" && delay > 2) {
      printVase(year()+"_"+month()+"_"+day()+"_"+hour()+"_"+minute()+"_"+second());
      saveStep = "saved";
      delay = 0;
    }
  }
}


void keyPressed() {
  if (key == 's' || key == 'S') {
    saveFrame("test-#########.png");
  } else if (key == 'p' || key == 'P') {
    // printVase("test-#########.obj");
  }
} 

void mousePressed() {
  if (STAGE == 0) {
    if (stepButtons_0.get(0).mouseOver()) {
      STAGE = 1;
    }
  } else if (STAGE == 1) {
    if (stepButtons_1.get(0).mouseOver()) {
      loadPreview();
      STAGE = 2;
      if (changesMade) {
        updatePreviewVase();
        changesMade = false;
      }
    } else if (stepButtons_1.get(1).mouseOver()) {
      if (drawnInBox) {  
        drawnBoxSave = drawingBox.get(); 
        set4thBox();
      }
      drawingBox = loadImage(stepButtons_1.get(1).text);
      proportionDrawingBox();
      changesMade = true;
    } else if (stepButtons_1.get(2).mouseOver()) {
      if (drawnInBox) {  
        drawnBoxSave = drawingBox.get(); 
        set4thBox();
      }
      drawingBox = loadImage(stepButtons_1.get(2).text);
      proportionDrawingBox();
      changesMade = true;
    } else if (stepButtons_1.get(3).mouseOver()) {
      if (drawnInBox) {  
        drawnBoxSave = drawingBox.get();  
        set4thBox();
      }
      drawingBox = loadImage(stepButtons_1.get(3).text);
      proportionDrawingBox();
      changesMade = true;
    } else if (stepButtons_1.get(4).mouseOver()) {
      PImage tmp = drawnBoxSave.get();
      if (drawnInBox) {  
        drawnBoxSave = drawingBox.get(); 
        set4thBox();
      }
      drawingBox = tmp.get();
      proportionDrawingBox();
      drawnInBox = true;
      changesMade = true;
    } else if (stepButtons_1.get(5).mouseOver()) {
      stepButtons_1.get(5).clicked = true;
      selectInput("Select a file to process:", "fileSelected");
    }
    //  selectInput("Select a file to process:", "fileSelected");
  } else if (STAGE == 2) {
    if (stepButtons_2.get(0).mouseOver()) {
      STAGE = 3;
    } else if (stepButtons_2.get(1).mouseOver()) {
      if (outerImageWhite) {
        stepButtons_2.get(1).clicked = true;
        selectInput("Select a file to process:", "fileSelected");
      } else {
        newOuterPreviewImg = true;
        outerImageWhite = true;
        img1 = "nocutout.png";
        loadPreview();
      }
    } else if (stepButtons_2.get(2).mouseOver()) {
      if (innerImageWhite) {
        stepButtons_2.get(2).clicked = true;
        selectInput("Select a file to process:", "fileSelected");
      } else {
        newInnerPreviewImg = true;
        innerImageWhite = true;
        img2 = "nocutout.png";
        loadPreview();
      }
    }
  } else if (STAGE == 3) {
    if (saveScreenUp == true) {
      if (saveButtons.get(0).mouseOver()) {
        saveScreenUp = false;
      } else if (saveButtons.get(1).mouseOver()) {
        exit();
      }
    } else if (stepButtons_3.get(0).mouseOver()) {
      folderName = session_name+hour()+"_"+minute()+"_"+second()+"/";
      save(folderName+year()+"_"+month()+"_"+day()+"_"+hour()+"_"+minute()+"_"+second()+"-preview.png");
      saveScreenUp = true;
      saveStep = "saving";
      // printVase(year()+"_"+month()+"_"+day()+"_"+hour()+"_"+minute()+"_"+second());
      // saveStep = "saved";
    } else if (vaseHEIGHT_inches.mouseOver()) {
      if (vaseHEIGHT_inches.arrows.get(0).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(0, 1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(1).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(1, 1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(2).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(2, 1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(3).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(0, -1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(4).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(1, -1);
        setWIDTHbasedOnHEIGHT(true);
      } else if (vaseHEIGHT_inches.arrows.get(5).mouseOver()) {
        vaseHEIGHT_inches.addOrSubtract(2, -1);
        setWIDTHbasedOnHEIGHT(true);
      }
    } else if (vaseWIDTH_inches.mouseOver()) {
      if (vaseWIDTH_inches.arrows.get(0).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(0, 1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(1).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(1, 1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(2).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(2, 1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(3).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(0, -1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(4).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(1, -1);
        setHEIGHTbasedOnWIDTH(true);
      } else if (vaseWIDTH_inches.arrows.get(5).mouseOver()) {
        vaseWIDTH_inches.addOrSubtract(2, -1);
        setHEIGHTbasedOnWIDTH(true);
      }
    }
  }

  // check for top buttons

  if (saveScreenUp == false && PVector.dist(new PVector(steps_center-steps_inBetween, steps_distFromTop+steps_orbSize), new PVector(mouseX, mouseY)) < steps_orbSize) { // 1
    STAGE = 1;
  } else if (saveScreenUp == false && PVector.dist(new PVector(steps_center, steps_distFromTop+steps_orbSize), new PVector(mouseX, mouseY)) < steps_orbSize) { // 1
    loadPreview();
    STAGE = 2;
    if (changesMade) {
      updatePreviewVase();
      changesMade = false;
    }
  } else if (saveScreenUp == false && PVector.dist(new PVector(steps_center+ steps_inBetween, steps_distFromTop+steps_orbSize), new PVector(mouseX, mouseY)) < steps_orbSize) { // 1
    loadPreview();
    STAGE = 3;
    if (changesMade) {
      updatePreviewVase();
      changesMade = false;
    }
  }
}





void mouseDragged() 
{
  // if inside box
  if (STAGE==1 && mouseX > dB_x - dB_wid && mouseX < dB_x + dB_wid && mouseY > dB_y && mouseY < dB_y + dB_hei) {
    drawInBox1();
  }
}
