
/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
class inchScale {

  float xPos;
  float yPos;
  ArrayList<BoxButton> arrows;
  String txt;
  int textSizeWords = 16;
  int textSizeNumbers = 32;


  IntList digits = new IntList();


  inchScale(float x, float y, String t, float startingValue) {
    xPos = x;
    yPos = y;
    txt = t;

    arrows = new ArrayList<BoxButton>();
    arrows.add(new BoxButton(xPos-55, yPos-40, 30, 17, "1", 21, true));
    arrows.add(new BoxButton(xPos-15, yPos-40, 30, 17, ".1", 21, true));
    arrows.add(new BoxButton(xPos+25, yPos-40, 30, 17, ".01", 21, true));
    arrows.add(new BoxButton(xPos-55, yPos+40, 30, 17, "1", 22, true));
    arrows.add(new BoxButton(xPos-15, yPos+40, 30, 17, ".1", 22, true));
    arrows.add(new BoxButton(xPos+25, yPos+40, 30, 17, ".01", 22, true));

    setNumbers(startingValue);
  }

  void setNumbers(float v) {
    digits.set(0, int(v));
    digits.set(1, int((v*10) % 10));
    digits.set(2, int((v*100) % 10));
  }

  float getNumberInches() {
    float d = float(digits.get(0)) + (float(digits.get(1))/10) + (float(digits.get(2))/100);
    return d;
  }

  float getNumberMilimeters() {
    float d = 25.4 * (float(digits.get(0)) + (float(digits.get(1))/10) + (float(digits.get(2))/100));
    return d;
  }

  void addOrSubtract(int digi, int direction) {
    digits.set(digi, digits.get(digi) + direction );

    if (digits.get(digi) > 9 ) {
      if (digi == 0) {  
        digits.set(digi, 9);
      } else { 
        digits.set(digi, digits.get(digi)-10);
        if (digi > 0) {
          addOrSubtract(digi-1, direction);
        }
      }
    } else if (digits.get(digi) < 0 ) {
    
        digits.set(digi, digits.get(digi)+10);
      if (digi > 0) {
        addOrSubtract(digi-1, direction);
      }
     
    }
  }

  Boolean mouseOver() {  
    if (mouseX > xPos-55 && mouseX < xPos+55 && mouseY > yPos-40 && mouseY < yPos+57) {
      return true;
    } else {
      return false;
    }
  }


  void render() {

    for (int i=0; i<arrows.size(); i++) {
      arrows.get(i).render(true);
    }
    fill(200);
    textSize(textSizeWords);
    text(txt, xPos+100, yPos+0);
    textSize(textSizeNumbers);
    text(digits.get(0), xPos-40, yPos+20);
    text(digits.get(1), xPos, yPos+20);
    text(digits.get(2), xPos+40, yPos+20);
    text(".", xPos-20, yPos+20);
  }
}

inchScale vaseHEIGHT_inches;
inchScale vaseWIDTH_inches;


void setupInchScales() {
  vaseHEIGHT_inches = new inchScale(125, 300, "height\n(inches)", 4.50);
  vaseWIDTH_inches = new inchScale(450, 520, "width\n(inches)", 2.98);
}


void setWIDTHbasedOnHEIGHT(Boolean rescaleVase) {
  float tmp = vaseHEIGHT_inches.getNumberInches() * (outline_width/outline_height);
  if (tmp < 10) {
    vaseWIDTH_inches.setNumbers(tmp);
  } else {
    vaseWIDTH_inches.setNumbers(9.99);
    setHEIGHTbasedOnWIDTH(rescaleVase);
  }
  if (rescaleVase) {  
    changesMadeStep3 = true;
  }
}

void setHEIGHTbasedOnWIDTH(Boolean rescaleVase) {

  float tmp = vaseWIDTH_inches.getNumberInches() * (outline_height/outline_width);
  if (tmp < 10) {
    vaseHEIGHT_inches.setNumbers(tmp);
  } else {
    vaseHEIGHT_inches.setNumbers(9.99);  
    setWIDTHbasedOnHEIGHT(rescaleVase);
  }
  if (rescaleVase) {  
    changesMadeStep3 = true;
  }
}
