
/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
PVector warp(PVector input, boolean outer) {  
  PVector output = new PVector(input.x, input.y, input.z);

  float originalY = output.y;


  // output example: test1.png, spiral2.png, cutThru.png
  // outer: 5, inner: 5
  /* output.x = changeByVar(output.x, originalY, .01);  
   output.z = changeByVar(output.z, originalY, .01);
   output = arcXbyY(output, 100, -.2, .03);
   output.z = moveByVar(output.z, originalY, .5);
   //*/


  // mary neubauer bronze sculpture /// sea life vase
  // test0.png, mbronze_cut, mbronze_out, mbronze_in,
  /// outer: 15, inner: 5
  /* if (originalY > 200) {
   output.x = changeByVar(output.x, originalY-200, -.003);  
   output.z = changeByVar(output.z, originalY-200, -.003);
   }
   if (originalY < 150) {
   output = flowerY(output, new PVector(50, 150), .005*(150-originalY) );
   output.y = rippleY(output, (150-originalY)/15, 8.0, 0);
   }//*/


/*
  // snake swallowing its own tail
  // test0.png, snakeSkin.png, snaketeeth.png, nocutout.png
  // outer: 5 inner: 15
  int g = 100;
  if (originalY < g) {
    output = flowerY(output, new PVector(50, g), .005*(g-originalY) );
    output.y = rippleY(output, (g-originalY)/15, 2.0, -PI/2);
  }
  int s1 = 0;
  int s2 = 100;
  if (outer && originalY >= s1 && originalY <= s2) {
    output = bulgeXZ(output, originalY, s1, 10, 30, s2, -PI/2, -PI/8, PI/8, PI/2, 30.0);
  }
  output = arcXbyY(output, 200, 0, .025);
  //*/ //*/



  // you're only ****ing yourself
  /*//test0.png, nocutout.png
   int g = 100;
   if (originalY < g) {
   output = flowerY(output, new PVector(50, g), .005*(g-originalY) );
   output.y = rippleY(output, (g-originalY)/15, 8.0, 0);
   }
   int s1 = 240;
  int s2 = 300;
  int mid = 260;
  if (outer && originalY >= s1 && originalY <= s2) {
    output = bulgeXZ(output, originalY, s1, mid, mid, s2, -PI, -PI, PI, PI, 30.0);
  }
   output = arcXbyY(output, 150, 0, .0225);
   //*/





  return output;
}



float changeByVar(float x, float y, float s) {
  return (x / ((y*s)+1));
}

float moveByVar(float x, float y, float s) {
  return (x + (y*s));
}

PVector arcXbyY(PVector o, float radius, float radius_scaler, float a) {

  float angle = a * o.y;
  float mag = (radius+(radius_scaler*o.y)) + o.x;
  PVector p = PVector.fromAngle(angle);
  p.setMag(mag);

  o.x = p.x;
  o.y = p.y;

  return o;
}



PVector flowerY(PVector o, PVector ro, float a ) {

  PVector o2 = new PVector(  sqrt(pow(o.x, 2)+pow(o.z, 2)) -ro.x, o.y-ro.y);
  o2.rotate(a);

  float xzheading = ( new PVector(o.x, o.z)  ).heading();
  PVector oxz = new PVector(o2.x +ro.x, 0);
  oxz.rotate(xzheading);

  o = new PVector( oxz.x, o2.y+ro.y, oxz.y);


  return o;
}



float rippleY(PVector o, float scaler, float ripples, float trans) {

  float ang = (new PVector(o.x, o.z)).heading();
  float rip = sin(trans+(ang*ripples))*scaler;

  o.y += rip;

  return o.y;
}


//(output, s1, 75, 75, s2, PI*3/2, PI*7/8 , PI/8, PI/2 , 50.0);
PVector bulgeXZ( PVector o, float posY, int start, int startMid, int endMid, int end, 
  float angStart, float angMaxStart, float angMaxEnd, float angEnd, 
  float bulgeAmount) {

  PVector xz = new PVector(o.x, o.z);
  float xzdir = xz.heading();

  float coefficient1 = 1;
  float coefficient2 = 0;

  // set coeffient 1, based on Y
  //////////////////////////////////////////////////////////////////
  if (posY >= start && posY <= startMid) {
    if (start == startMid) {
      coefficient1 = 1;
    } else {
      coefficient1 = (posY-start)/(startMid-start);
    }
  } else if (posY >= startMid && posY <= endMid) {
    coefficient1 = 1;
  } else if (posY >= endMid && posY <= end) {
    if (start == startMid) {
      coefficient1 = 1;
    } else {
      coefficient1 = 1-((posY-endMid)/(end-endMid));
    }
  }

  if (coefficient1<=.5) {
    coefficient1 = (pow(coefficient1*2, 2))/2;
  } else {
    coefficient1 = 1-((pow((1-coefficient1)*2, 2))/2);
  }
  //////////////////////////////////////////////////////////////////

  // set coefficnet2 based on angle
  //////////////////////////////////////////////////////////////////
  // if normal
  if (angStart<=angMaxStart && angStart<=xzdir && xzdir<=angMaxStart) {
    if (angStart==angMaxStart) {
      coefficient2 = 1;
    } else {
      coefficient2 = (xzdir-angStart)/(angMaxStart-angStart);
    }
  }
  //if crosses median
  else if (angStart>angMaxStart && (xzdir>=angStart || xzdir<=angMaxStart)) {
    if (xzdir>=angStart) {  
      angMaxStart+=(2*PI);
    } else {  
      angStart-=(2*PI);
    }
    coefficient2 = (xzdir-angStart)/(angMaxStart-angStart);
  }
  // if normal middle
  else if (angMaxStart<=angMaxEnd && angMaxStart<=xzdir && xzdir<=angMaxEnd) {
    coefficient2 = 1;
  }
  //if crosses median
  else if (angMaxStart>angMaxEnd && (xzdir>=angMaxStart || xzdir<=angMaxEnd)) {
    coefficient2 = 1;
  }
  // normal
  else if (angMaxEnd<=angEnd && angMaxEnd<=xzdir && xzdir<=angEnd) {
    if (angMaxEnd==angEnd) {
      coefficient2 = 1;
    } else {
      coefficient2 = 1-((xzdir-angMaxEnd)/(angEnd-angMaxEnd));
    }
  }
  //if crosses median
  else if (angMaxEnd>angEnd && (xzdir>=angMaxEnd || xzdir<=angEnd)) {
    if (xzdir>=angMaxEnd) {  
      angEnd+=(2*PI);
    } else {  
      angMaxEnd-=(2*PI);
    }
    coefficient2 = 1-((xzdir-angMaxEnd)/(angEnd-angMaxEnd));
  }







  if (coefficient2<=.5) {
    coefficient2 = (pow(coefficient2*2, 2))/2;
  } else {
    coefficient2 = 1-((pow((1-coefficient2)*2, 2))/2);
  }
  //////////////////////////////////////////////////////////////////

  float coefficient_full = coefficient1 * coefficient2;
  float newMag = xz.mag() + (coefficient_full * bulgeAmount);
  xz.setMag(newMag);
  o.x = xz.x;
  o.z = xz.y;




  return o;
}
